#include "C:/Programme/pure-systems/AspectC++ Add-In/include/vsbasics.h"

#line 1 "C:/DA/ACSTUTestCAA/PROQMFW/PROQMActions.m/src/Action3.cpp"
#ifndef __ac_FIRST_C__DA_ACSTUTestCAA__
#define __ac_FIRST_C__DA_ACSTUTestCAA__
#define __ac_FIRST_FILE_C__DA_ACSTUTestCAA_PROQMFW_PROQMActions_m_src_Action3_cpp__
#endif // __ac_FIRST_C__DA_ACSTUTestCAA__

#line 1 "C:/DA/ACSTUTestCAA/PROQMFW/PROQMActions.m/src/Action3.cpp"

#line 12 "C:/DA/ACSTUTestCAA/Aspects/PROQMActions.m/src/Action3.cpp"

#ifndef __ac_h_
#define __ac_h_
namespace AC {
  typedef const char* Type;
  enum JPType { CALL = 0x0004, EXECUTION = 0x0008, CONSTRUCTION = 0x0010, DESTRUCTION = 0x0020 };
  struct Action {
    void **_args; void *_result; void *_target; void *_that; void *_fptr;
    void (*_wrapper)(Action &);
    inline void trigger () { _wrapper (*this); }
  };
  struct AnyResultBuffer {};
  template <typename T> struct ResultBuffer : public AnyResultBuffer {
    char _data[sizeof (T)];
    ~ResultBuffer () { ((T*)_data)->T::~T(); }
    operator T& () const { return *(T*)_data; }
  };
  template <class Aspect, int Index>
  struct CFlow {
    static int &instance () {
      static int counter = 0;
      return counter;
    }
    CFlow () { instance ()++; }
    ~CFlow () { instance ()--; }
    static bool active () { return instance () > 0; }
  };
}
inline void * operator new (unsigned int, AC::AnyResultBuffer *p) { return p; }
inline void operator delete (void *, AC::AnyResultBuffer *) { } // for VC++
#endif // __ac_h_

#line 1 "C:/DA/ACSTUTestCAA/PROQMFW/PROQMActions.m/src/Action3.cpp"

#line 1 "C:/DA/ACSTUTestCAA/PROQMFW/PROQMActions.m/src/Action3.cpp"

#line 49 "C:/DA/ACSTUTestCAA/Aspects/PROQMActions.m/src/Action3.cpp"

#ifndef __ac_fwd_Profiling__
#define __ac_fwd_Profiling__
class Profiling;
namespace AC {
  template <class JoinPoint>
  inline void invoke_Profiling_Profiling_a0_before (JoinPoint *tjp);
  template <class JoinPoint>
  inline void invoke_Profiling_Profiling_a1_after (JoinPoint *tjp);
  template <class JoinPoint>
  inline void invoke_Profiling_Profiling_a2_after (JoinPoint *tjp);
}
#endif

#ifndef __ac_need_C__DA_ACSTUTestCAA_Aspects_Profiling_ah__
#define __ac_need_C__DA_ACSTUTestCAA_Aspects_Profiling_ah__
#endif

#ifndef __ac_fwd_IndentedLogging__
#define __ac_fwd_IndentedLogging__
class IndentedLogging;
namespace AC {
  template <class JoinPoint>
  inline void invoke_IndentedLogging_IndentedLogging_a0_before (JoinPoint *tjp);
  template <class JoinPoint>
  inline void invoke_IndentedLogging_IndentedLogging_a1_after (JoinPoint *tjp);
}
#endif

#ifndef __ac_need_C__DA_ACSTUTestCAA_Aspects_IndentedLogging_ah__
#define __ac_need_C__DA_ACSTUTestCAA_Aspects_IndentedLogging_ah__
#endif

#line 1 "C:/DA/ACSTUTestCAA/PROQMFW/PROQMActions.m/src/Action3.cpp"
#ifndef OS
#define OS Windows_NT
#endif
#ifndef _WINDOWS_SOURCE
#define _WINDOWS_SOURCE Windows_NT
#define __PROQMActions
#endif


#line 1 "C:/DA/ACSTUTestCAA/PROQMFW/ProtectedInterfaces/Action3.h"

#line 95 "C:/DA/ACSTUTestCAA/Aspects/PROQMActions.m/src/Action3.cpp"

#ifndef __ac_fwd_IndentedLogging__
#define __ac_fwd_IndentedLogging__
class IndentedLogging;
namespace AC {
  template <class JoinPoint>
  inline void invoke_IndentedLogging_IndentedLogging_a0_before (JoinPoint *tjp);
  template <class JoinPoint>
  inline void invoke_IndentedLogging_IndentedLogging_a1_after (JoinPoint *tjp);
}
#endif

#ifndef __ac_need_C__DA_ACSTUTestCAA_Aspects_IndentedLogging_ah__
#define __ac_need_C__DA_ACSTUTestCAA_Aspects_IndentedLogging_ah__
#endif

#line 1 "C:/DA/ACSTUTestCAA/PROQMFW/ProtectedInterfaces/Action3.h"
#ifndef Action3_H
#define Action3_H

#line 1 "C:/DA/ACSTUTestCAA/PROQMFW/PublicInterfaces/PROQMActions.h"
#ifdef  _WINDOWS_SOURCE
#ifdef  __PROQMActions
#define ExportedByPROQMActions     __declspec(dllexport)
#else
#define ExportedByPROQMActions     __declspec(dllimport)
#endif
#else
#define ExportedByPROQMActions
#endif

#line 4 "C:/DA/ACSTUTestCAA/PROQMFW/ProtectedInterfaces/Action3.h"
#include <iostream>


#line 131 "C:/DA/ACSTUTestCAA/Aspects/PROQMActions.m/src/Action3.cpp"
class ErrorHandling;
class Profiling;
class IndentedLogging;

#line 6 "C:/DA/ACSTUTestCAA/PROQMFW/ProtectedInterfaces/Action3.h"
class ExportedByPROQMActions Action3
{
#line 139 "C:/DA/ACSTUTestCAA/Aspects/PROQMActions.m/src/Action3.cpp"
  friend class ::ErrorHandling;
  friend class ::Profiling;
  friend class ::IndentedLogging;

#line 7 "C:/DA/ACSTUTestCAA/PROQMFW/ProtectedInterfaces/Action3.h"

  public:
	  
#line 148 "C:/DA/ACSTUTestCAA/Aspects/PROQMActions.m/src/Action3.cpp"


struct TJP__ZN7Action3C1Ev_0 {
  typedef void Result;
  typedef ::Action3 That;
  typedef ::Action3 Target;
  static const int JPID = 169;
  static const AC::JPType JPTYPE = (AC::JPType)16;
  struct Res {
    typedef void Type;
    typedef void ReferredType;
  };
  enum { ARGS = 0 };
  template <int I> struct Arg {
    typedef void Type;
    typedef void ReferredType;
  };

  Target *_target;
  That *_that;

  inline static const char *signature () { return "Action3::Action3()";}
  inline Target *target() {return (Target*)_target;}
  inline That *that() {return (That*)_that;}

};


#line 9 "C:/DA/ACSTUTestCAA/PROQMFW/ProtectedInterfaces/Action3.h"
Action3 ()
#line 179 "C:/DA/ACSTUTestCAA/Aspects/PROQMActions.m/src/Action3.cpp"
{
  TJP__ZN7Action3C1Ev_0 tjp;
  tjp._target =  (TJP__ZN7Action3C1Ev_0::Target*)this;
  tjp._that =  (TJP__ZN7Action3C1Ev_0::That*)this;
  AC::invoke_IndentedLogging_IndentedLogging_a0_before<TJP__ZN7Action3C1Ev_0> (&tjp);
this->__exec_old_C1();
  AC::invoke_IndentedLogging_IndentedLogging_a1_after<TJP__ZN7Action3C1Ev_0> (&tjp);

}
inline void __exec_old_C1()
#line 9 "C:/DA/ACSTUTestCAA/PROQMFW/ProtectedInterfaces/Action3.h"
{	  
#ifdef _WINDOWS_SOURCE
	std::cout<<"_WINDOWS_SOURCE defined"<<std::endl;
#else
	std::cout<<"_WINDOWS_SOURCE not defined"<<std::endl;
#endif
#ifdef __PROQMActions
	std::cout<<"__PROQMActions defined"<<std::endl;
#else
	std::cout<<"__PROQMActions not defined"<<std::endl;
#endif
	std::cout<<"Action3::Action3()"<<std::endl;
	  }
	  
#line 205 "C:/DA/ACSTUTestCAA/Aspects/PROQMActions.m/src/Action3.cpp"


struct TJP__ZN7Action3D1Ev_0 {
  typedef void Result;
  typedef ::Action3 That;
  typedef ::Action3 Target;
  static const int JPID = 169;
  static const AC::JPType JPTYPE = (AC::JPType)32;
  struct Res {
    typedef void Type;
    typedef void ReferredType;
  };
  enum { ARGS = 0 };
  template <int I> struct Arg {
    typedef void Type;
    typedef void ReferredType;
  };

  Target *_target;
  That *_that;

  inline static const char *signature () { return "Action3::~Action3()";}
  inline Target *target() {return (Target*)_target;}
  inline That *that() {return (That*)_that;}

};


#line 22 "C:/DA/ACSTUTestCAA/PROQMFW/ProtectedInterfaces/Action3.h"
virtual ~Action3 ()
#line 236 "C:/DA/ACSTUTestCAA/Aspects/PROQMActions.m/src/Action3.cpp"
{
  TJP__ZN7Action3D1Ev_0 tjp;
  tjp._target =  (TJP__ZN7Action3D1Ev_0::Target*)this;
  tjp._that =  (TJP__ZN7Action3D1Ev_0::That*)this;
  AC::invoke_IndentedLogging_IndentedLogging_a0_before<TJP__ZN7Action3D1Ev_0> (&tjp);
this->__exec_old_D1();
  AC::invoke_IndentedLogging_IndentedLogging_a1_after<TJP__ZN7Action3D1Ev_0> (&tjp);

}
inline void __exec_old_D1()
#line 22 "C:/DA/ACSTUTestCAA/PROQMFW/ProtectedInterfaces/Action3.h"
{
	  	std::cout<<"virtual Action3::~Action3()"<<std::endl;
	}
	
#line 252 "C:/DA/ACSTUTestCAA/Aspects/PROQMActions.m/src/Action3.cpp"


struct TJP__ZN7Action3C1ER7Action3_0 {
  typedef void Result;
  typedef ::Action3 That;
  typedef ::Action3 Target;
  static const int JPID = 169;
  static const AC::JPType JPTYPE = (AC::JPType)16;
  struct Res {
    typedef void Type;
    typedef void ReferredType;
  };
  enum { ARGS = 1 };
  template <int I> struct Arg {
    typedef void Type;
    typedef void ReferredType;
  };
  template <> struct Arg<0> {
    typedef ::Action3 & Type;
    typedef ::Action3 ReferredType;
  };

  Target *_target;
  That *_that;

  inline static const char *signature () { return "Action3::Action3(Action3 &)";}
  inline Target *target() {return (Target*)_target;}
  inline That *that() {return (That*)_that;}

};


#line 25 "C:/DA/ACSTUTestCAA/PROQMFW/ProtectedInterfaces/Action3.h"
Action3(Action3&  arg0)
#line 287 "C:/DA/ACSTUTestCAA/Aspects/PROQMActions.m/src/Action3.cpp"
{
  TJP__ZN7Action3C1ER7Action3_0 tjp;
  tjp._target =  (TJP__ZN7Action3C1ER7Action3_0::Target*)this;
  tjp._that =  (TJP__ZN7Action3C1ER7Action3_0::That*)this;
  AC::invoke_IndentedLogging_IndentedLogging_a0_before<TJP__ZN7Action3C1ER7Action3_0> (&tjp);
this->__exec_old_C1(arg0);
  AC::invoke_IndentedLogging_IndentedLogging_a1_after<TJP__ZN7Action3C1ER7Action3_0> (&tjp);

}
inline void __exec_old_C1(::Action3 & original)
#line 25 "C:/DA/ACSTUTestCAA/PROQMFW/ProtectedInterfaces/Action3.h"
{}
	Action3& operator=(Action3& original){return *this;}

	int execute();
	int checkpoint();
	char* ClassName(){return "Action3";}
private:
	void printface();

};
#endif

#line 10 "C:/DA/ACSTUTestCAA/PROQMFW/PROQMActions.m/src/Action3.cpp"
void Action3::printface()
{
	int i,j;
	std::cout<<"\1\1"<<std::endl;
	for(i=1;i<15;i++)
	{
		for(j=1;j<=i;j++) std::cout<<(char)219<<(char)219;
		std::cout<<std::endl;
	}
}

int Action3::checkpoint(){
	std::cout << "Action3 checkpoint"<<std::endl;
	return 0;
}

#line 328 "C:/DA/ACSTUTestCAA/Aspects/PROQMActions.m/src/Action3.cpp"

struct TJP__ZN7Action37executeEv_1_0 {
  typedef int Result;
  typedef ::Action3 That;
  typedef ::Action3 Target;
  static const int JPID = 99;
  static const AC::JPType JPTYPE = (AC::JPType)4;
  struct Res {
    typedef int Type;
    typedef int ReferredType;
  };
  enum { ARGS = 0 };
  template <int I> struct Arg {
    typedef void Type;
    typedef void ReferredType;
  };

  Target *_target;
  That *_that;

  inline static const char *signature () { return "int Action3::checkpoint()";}
  inline Target *target() {return (Target*)_target;}
  inline That *that() {return (That*)_that;}

};


#line 25 "C:/DA/ACSTUTestCAA/PROQMFW/PROQMActions.m/src/Action3.cpp"

#line 358 "C:/DA/ACSTUTestCAA/Aspects/PROQMActions.m/src/Action3.cpp"

inline int __call__ZN7Action37executeEv_1_0 (::Action3 *srcthis, ::Action3 *dstthis){
  AC::ResultBuffer< int  > result;
  TJP__ZN7Action37executeEv_1_0 tjp;
  tjp._target =  (TJP__ZN7Action37executeEv_1_0::Target*)dstthis;
  tjp._that =  (TJP__ZN7Action37executeEv_1_0::That*)srcthis;
  AC::invoke_IndentedLogging_IndentedLogging_a0_before<TJP__ZN7Action37executeEv_1_0> (&tjp);
  ::new (&result) int  (dstthis->checkpoint());
  AC::invoke_IndentedLogging_IndentedLogging_a1_after<TJP__ZN7Action37executeEv_1_0> (&tjp);
  AC::invoke_Profiling_Profiling_a1_after<TJP__ZN7Action37executeEv_1_0> (&tjp);
  return (int &)result;
 }

#line 25 "C:/DA/ACSTUTestCAA/PROQMFW/PROQMActions.m/src/Action3.cpp"

#line 374 "C:/DA/ACSTUTestCAA/Aspects/PROQMActions.m/src/Action3.cpp"

struct TJP__ZN7Action37executeEv_3_0 {
  typedef int Result;
  typedef ::Action3 That;
  typedef ::Action3 Target;
  static const int JPID = 100;
  static const AC::JPType JPTYPE = (AC::JPType)4;
  struct Res {
    typedef int Type;
    typedef int ReferredType;
  };
  enum { ARGS = 0 };
  template <int I> struct Arg {
    typedef void Type;
    typedef void ReferredType;
  };

  Target *_target;
  That *_that;

  inline static const char *signature () { return "int Action3::checkpoint()";}
  inline Target *target() {return (Target*)_target;}
  inline That *that() {return (That*)_that;}

};


#line 25 "C:/DA/ACSTUTestCAA/PROQMFW/PROQMActions.m/src/Action3.cpp"

#line 404 "C:/DA/ACSTUTestCAA/Aspects/PROQMActions.m/src/Action3.cpp"

inline int __call__ZN7Action37executeEv_3_0 (::Action3 *srcthis, ::Action3 *dstthis){
  AC::ResultBuffer< int  > result;
  TJP__ZN7Action37executeEv_3_0 tjp;
  tjp._target =  (TJP__ZN7Action37executeEv_3_0::Target*)dstthis;
  tjp._that =  (TJP__ZN7Action37executeEv_3_0::That*)srcthis;
  AC::invoke_IndentedLogging_IndentedLogging_a0_before<TJP__ZN7Action37executeEv_3_0> (&tjp);
  ::new (&result) int  (dstthis->checkpoint());
  AC::invoke_IndentedLogging_IndentedLogging_a1_after<TJP__ZN7Action37executeEv_3_0> (&tjp);
  AC::invoke_Profiling_Profiling_a1_after<TJP__ZN7Action37executeEv_3_0> (&tjp);
  return (int &)result;
 }

#line 25 "C:/DA/ACSTUTestCAA/PROQMFW/PROQMActions.m/src/Action3.cpp"

#line 420 "C:/DA/ACSTUTestCAA/Aspects/PROQMActions.m/src/Action3.cpp"

struct TJP__ZN7Action37executeEv_5_0 {
  typedef int Result;
  typedef ::Action3 That;
  typedef ::Action3 Target;
  static const int JPID = 101;
  static const AC::JPType JPTYPE = (AC::JPType)4;
  struct Res {
    typedef int Type;
    typedef int ReferredType;
  };
  enum { ARGS = 0 };
  template <int I> struct Arg {
    typedef void Type;
    typedef void ReferredType;
  };

  Target *_target;
  That *_that;

  inline static const char *signature () { return "int Action3::checkpoint()";}
  inline Target *target() {return (Target*)_target;}
  inline That *that() {return (That*)_that;}

};


#line 25 "C:/DA/ACSTUTestCAA/PROQMFW/PROQMActions.m/src/Action3.cpp"

#line 450 "C:/DA/ACSTUTestCAA/Aspects/PROQMActions.m/src/Action3.cpp"

inline int __call__ZN7Action37executeEv_5_0 (::Action3 *srcthis, ::Action3 *dstthis){
  AC::ResultBuffer< int  > result;
  TJP__ZN7Action37executeEv_5_0 tjp;
  tjp._target =  (TJP__ZN7Action37executeEv_5_0::Target*)dstthis;
  tjp._that =  (TJP__ZN7Action37executeEv_5_0::That*)srcthis;
  AC::invoke_IndentedLogging_IndentedLogging_a0_before<TJP__ZN7Action37executeEv_5_0> (&tjp);
  ::new (&result) int  (dstthis->checkpoint());
  AC::invoke_IndentedLogging_IndentedLogging_a1_after<TJP__ZN7Action37executeEv_5_0> (&tjp);
  AC::invoke_Profiling_Profiling_a1_after<TJP__ZN7Action37executeEv_5_0> (&tjp);
  return (int &)result;
 }

#line 25 "C:/DA/ACSTUTestCAA/PROQMFW/PROQMActions.m/src/Action3.cpp"

#line 466 "C:/DA/ACSTUTestCAA/Aspects/PROQMActions.m/src/Action3.cpp"

struct TJP__ZN7Action37executeEv_7_0 {
  typedef int Result;
  typedef ::Action3 That;
  typedef ::Action3 Target;
  static const int JPID = 102;
  static const AC::JPType JPTYPE = (AC::JPType)4;
  struct Res {
    typedef int Type;
    typedef int ReferredType;
  };
  enum { ARGS = 0 };
  template <int I> struct Arg {
    typedef void Type;
    typedef void ReferredType;
  };

  Target *_target;
  That *_that;

  inline static const char *signature () { return "int Action3::checkpoint()";}
  inline Target *target() {return (Target*)_target;}
  inline That *that() {return (That*)_that;}

};


#line 25 "C:/DA/ACSTUTestCAA/PROQMFW/PROQMActions.m/src/Action3.cpp"

#line 496 "C:/DA/ACSTUTestCAA/Aspects/PROQMActions.m/src/Action3.cpp"

inline int __call__ZN7Action37executeEv_7_0 (::Action3 *srcthis, ::Action3 *dstthis){
  AC::ResultBuffer< int  > result;
  TJP__ZN7Action37executeEv_7_0 tjp;
  tjp._target =  (TJP__ZN7Action37executeEv_7_0::Target*)dstthis;
  tjp._that =  (TJP__ZN7Action37executeEv_7_0::That*)srcthis;
  AC::invoke_IndentedLogging_IndentedLogging_a0_before<TJP__ZN7Action37executeEv_7_0> (&tjp);
  ::new (&result) int  (dstthis->checkpoint());
  AC::invoke_IndentedLogging_IndentedLogging_a1_after<TJP__ZN7Action37executeEv_7_0> (&tjp);
  AC::invoke_Profiling_Profiling_a1_after<TJP__ZN7Action37executeEv_7_0> (&tjp);
  return (int &)result;
 }

#line 25 "C:/DA/ACSTUTestCAA/PROQMFW/PROQMActions.m/src/Action3.cpp"

#line 512 "C:/DA/ACSTUTestCAA/Aspects/PROQMActions.m/src/Action3.cpp"

struct TJP__ZN7Action37executeEv_9_0 {
  typedef int Result;
  typedef ::Action3 That;
  typedef ::Action3 Target;
  static const int JPID = 103;
  static const AC::JPType JPTYPE = (AC::JPType)4;
  struct Res {
    typedef int Type;
    typedef int ReferredType;
  };
  enum { ARGS = 0 };
  template <int I> struct Arg {
    typedef void Type;
    typedef void ReferredType;
  };

  Target *_target;
  That *_that;

  inline static const char *signature () { return "int Action3::checkpoint()";}
  inline Target *target() {return (Target*)_target;}
  inline That *that() {return (That*)_that;}

};


#line 25 "C:/DA/ACSTUTestCAA/PROQMFW/PROQMActions.m/src/Action3.cpp"

#line 542 "C:/DA/ACSTUTestCAA/Aspects/PROQMActions.m/src/Action3.cpp"

inline int __call__ZN7Action37executeEv_9_0 (::Action3 *srcthis, ::Action3 *dstthis){
  AC::ResultBuffer< int  > result;
  TJP__ZN7Action37executeEv_9_0 tjp;
  tjp._target =  (TJP__ZN7Action37executeEv_9_0::Target*)dstthis;
  tjp._that =  (TJP__ZN7Action37executeEv_9_0::That*)srcthis;
  AC::invoke_IndentedLogging_IndentedLogging_a0_before<TJP__ZN7Action37executeEv_9_0> (&tjp);
  ::new (&result) int  (dstthis->checkpoint());
  AC::invoke_IndentedLogging_IndentedLogging_a1_after<TJP__ZN7Action37executeEv_9_0> (&tjp);
  AC::invoke_Profiling_Profiling_a1_after<TJP__ZN7Action37executeEv_9_0> (&tjp);
  return (int &)result;
 }

#line 25 "C:/DA/ACSTUTestCAA/PROQMFW/PROQMActions.m/src/Action3.cpp"

#line 558 "C:/DA/ACSTUTestCAA/Aspects/PROQMActions.m/src/Action3.cpp"

struct TJP__ZN7Action37executeEv_11_0 {
  typedef int Result;
  typedef ::Action3 That;
  typedef ::Action3 Target;
  static const int JPID = 104;
  static const AC::JPType JPTYPE = (AC::JPType)4;
  struct Res {
    typedef int Type;
    typedef int ReferredType;
  };
  enum { ARGS = 0 };
  template <int I> struct Arg {
    typedef void Type;
    typedef void ReferredType;
  };

  Target *_target;
  That *_that;

  inline static const char *signature () { return "int Action3::checkpoint()";}
  inline Target *target() {return (Target*)_target;}
  inline That *that() {return (That*)_that;}

};


#line 25 "C:/DA/ACSTUTestCAA/PROQMFW/PROQMActions.m/src/Action3.cpp"

#line 588 "C:/DA/ACSTUTestCAA/Aspects/PROQMActions.m/src/Action3.cpp"

inline int __call__ZN7Action37executeEv_11_0 (::Action3 *srcthis, ::Action3 *dstthis){
  AC::ResultBuffer< int  > result;
  TJP__ZN7Action37executeEv_11_0 tjp;
  tjp._target =  (TJP__ZN7Action37executeEv_11_0::Target*)dstthis;
  tjp._that =  (TJP__ZN7Action37executeEv_11_0::That*)srcthis;
  AC::invoke_IndentedLogging_IndentedLogging_a0_before<TJP__ZN7Action37executeEv_11_0> (&tjp);
  ::new (&result) int  (dstthis->checkpoint());
  AC::invoke_IndentedLogging_IndentedLogging_a1_after<TJP__ZN7Action37executeEv_11_0> (&tjp);
  AC::invoke_Profiling_Profiling_a1_after<TJP__ZN7Action37executeEv_11_0> (&tjp);
  return (int &)result;
 }

#line 25 "C:/DA/ACSTUTestCAA/PROQMFW/PROQMActions.m/src/Action3.cpp"

#line 604 "C:/DA/ACSTUTestCAA/Aspects/PROQMActions.m/src/Action3.cpp"

struct TJP__ZN7Action37executeEv_13_0 {
  typedef int Result;
  typedef ::Action3 That;
  typedef ::Action3 Target;
  static const int JPID = 105;
  static const AC::JPType JPTYPE = (AC::JPType)4;
  struct Res {
    typedef int Type;
    typedef int ReferredType;
  };
  enum { ARGS = 0 };
  template <int I> struct Arg {
    typedef void Type;
    typedef void ReferredType;
  };

  Target *_target;
  That *_that;

  inline static const char *signature () { return "int Action3::checkpoint()";}
  inline Target *target() {return (Target*)_target;}
  inline That *that() {return (That*)_that;}

};


#line 25 "C:/DA/ACSTUTestCAA/PROQMFW/PROQMActions.m/src/Action3.cpp"

#line 634 "C:/DA/ACSTUTestCAA/Aspects/PROQMActions.m/src/Action3.cpp"

inline int __call__ZN7Action37executeEv_13_0 (::Action3 *srcthis, ::Action3 *dstthis){
  AC::ResultBuffer< int  > result;
  TJP__ZN7Action37executeEv_13_0 tjp;
  tjp._target =  (TJP__ZN7Action37executeEv_13_0::Target*)dstthis;
  tjp._that =  (TJP__ZN7Action37executeEv_13_0::That*)srcthis;
  AC::invoke_IndentedLogging_IndentedLogging_a0_before<TJP__ZN7Action37executeEv_13_0> (&tjp);
  ::new (&result) int  (dstthis->checkpoint());
  AC::invoke_IndentedLogging_IndentedLogging_a1_after<TJP__ZN7Action37executeEv_13_0> (&tjp);
  AC::invoke_Profiling_Profiling_a1_after<TJP__ZN7Action37executeEv_13_0> (&tjp);
  return (int &)result;
 }

#line 25 "C:/DA/ACSTUTestCAA/PROQMFW/PROQMActions.m/src/Action3.cpp"

#line 650 "C:/DA/ACSTUTestCAA/Aspects/PROQMActions.m/src/Action3.cpp"

struct TJP__ZN7Action37executeEv_15_0 {
  typedef int Result;
  typedef ::Action3 That;
  typedef ::Action3 Target;
  static const int JPID = 106;
  static const AC::JPType JPTYPE = (AC::JPType)4;
  struct Res {
    typedef int Type;
    typedef int ReferredType;
  };
  enum { ARGS = 0 };
  template <int I> struct Arg {
    typedef void Type;
    typedef void ReferredType;
  };

  Target *_target;
  That *_that;

  inline static const char *signature () { return "int Action3::checkpoint()";}
  inline Target *target() {return (Target*)_target;}
  inline That *that() {return (That*)_that;}

};


#line 25 "C:/DA/ACSTUTestCAA/PROQMFW/PROQMActions.m/src/Action3.cpp"

#line 680 "C:/DA/ACSTUTestCAA/Aspects/PROQMActions.m/src/Action3.cpp"

inline int __call__ZN7Action37executeEv_15_0 (::Action3 *srcthis, ::Action3 *dstthis){
  AC::ResultBuffer< int  > result;
  TJP__ZN7Action37executeEv_15_0 tjp;
  tjp._target =  (TJP__ZN7Action37executeEv_15_0::Target*)dstthis;
  tjp._that =  (TJP__ZN7Action37executeEv_15_0::That*)srcthis;
  AC::invoke_IndentedLogging_IndentedLogging_a0_before<TJP__ZN7Action37executeEv_15_0> (&tjp);
  ::new (&result) int  (dstthis->checkpoint());
  AC::invoke_IndentedLogging_IndentedLogging_a1_after<TJP__ZN7Action37executeEv_15_0> (&tjp);
  AC::invoke_Profiling_Profiling_a1_after<TJP__ZN7Action37executeEv_15_0> (&tjp);
  return (int &)result;
 }

#line 25 "C:/DA/ACSTUTestCAA/PROQMFW/PROQMActions.m/src/Action3.cpp"

#line 696 "C:/DA/ACSTUTestCAA/Aspects/PROQMActions.m/src/Action3.cpp"

struct TJP__ZN7Action37executeEv_17_0 {
  typedef int Result;
  typedef ::Action3 That;
  typedef ::Action3 Target;
  static const int JPID = 107;
  static const AC::JPType JPTYPE = (AC::JPType)4;
  struct Res {
    typedef int Type;
    typedef int ReferredType;
  };
  enum { ARGS = 0 };
  template <int I> struct Arg {
    typedef void Type;
    typedef void ReferredType;
  };

  Target *_target;
  That *_that;

  inline static const char *signature () { return "int Action3::checkpoint()";}
  inline Target *target() {return (Target*)_target;}
  inline That *that() {return (That*)_that;}

};


#line 25 "C:/DA/ACSTUTestCAA/PROQMFW/PROQMActions.m/src/Action3.cpp"

#line 726 "C:/DA/ACSTUTestCAA/Aspects/PROQMActions.m/src/Action3.cpp"

inline int __call__ZN7Action37executeEv_17_0 (::Action3 *srcthis, ::Action3 *dstthis){
  AC::ResultBuffer< int  > result;
  TJP__ZN7Action37executeEv_17_0 tjp;
  tjp._target =  (TJP__ZN7Action37executeEv_17_0::Target*)dstthis;
  tjp._that =  (TJP__ZN7Action37executeEv_17_0::That*)srcthis;
  AC::invoke_IndentedLogging_IndentedLogging_a0_before<TJP__ZN7Action37executeEv_17_0> (&tjp);
  ::new (&result) int  (dstthis->checkpoint());
  AC::invoke_IndentedLogging_IndentedLogging_a1_after<TJP__ZN7Action37executeEv_17_0> (&tjp);
  AC::invoke_Profiling_Profiling_a1_after<TJP__ZN7Action37executeEv_17_0> (&tjp);
  return (int &)result;
 }

#line 25 "C:/DA/ACSTUTestCAA/PROQMFW/PROQMActions.m/src/Action3.cpp"

#line 742 "C:/DA/ACSTUTestCAA/Aspects/PROQMActions.m/src/Action3.cpp"

struct TJP__ZN7Action37executeEv_19_0 {
  typedef int Result;
  typedef ::Action3 That;
  typedef ::Action3 Target;
  static const int JPID = 108;
  static const AC::JPType JPTYPE = (AC::JPType)4;
  struct Res {
    typedef int Type;
    typedef int ReferredType;
  };
  enum { ARGS = 0 };
  template <int I> struct Arg {
    typedef void Type;
    typedef void ReferredType;
  };

  Target *_target;
  That *_that;

  inline static const char *signature () { return "int Action3::checkpoint()";}
  inline Target *target() {return (Target*)_target;}
  inline That *that() {return (That*)_that;}

};


#line 25 "C:/DA/ACSTUTestCAA/PROQMFW/PROQMActions.m/src/Action3.cpp"

#line 772 "C:/DA/ACSTUTestCAA/Aspects/PROQMActions.m/src/Action3.cpp"

inline int __call__ZN7Action37executeEv_19_0 (::Action3 *srcthis, ::Action3 *dstthis){
  AC::ResultBuffer< int  > result;
  TJP__ZN7Action37executeEv_19_0 tjp;
  tjp._target =  (TJP__ZN7Action37executeEv_19_0::Target*)dstthis;
  tjp._that =  (TJP__ZN7Action37executeEv_19_0::That*)srcthis;
  AC::invoke_IndentedLogging_IndentedLogging_a0_before<TJP__ZN7Action37executeEv_19_0> (&tjp);
  ::new (&result) int  (dstthis->checkpoint());
  AC::invoke_IndentedLogging_IndentedLogging_a1_after<TJP__ZN7Action37executeEv_19_0> (&tjp);
  AC::invoke_Profiling_Profiling_a1_after<TJP__ZN7Action37executeEv_19_0> (&tjp);
  return (int &)result;
 }

#line 25 "C:/DA/ACSTUTestCAA/PROQMFW/PROQMActions.m/src/Action3.cpp"

#line 788 "C:/DA/ACSTUTestCAA/Aspects/PROQMActions.m/src/Action3.cpp"

struct TJP__ZN7Action37executeEv_0_0 {
  typedef void Result;
  typedef ::Action3 That;
  typedef ::Action3 Target;
  static const int JPID = 132;
  static const AC::JPType JPTYPE = (AC::JPType)4;
  struct Res {
    typedef void Type;
    typedef void ReferredType;
  };
  enum { ARGS = 0 };
  template <int I> struct Arg {
    typedef void Type;
    typedef void ReferredType;
  };

  Target *_target;
  That *_that;

  inline static const char *signature () { return "void Action3::printface()";}
  inline Target *target() {return (Target*)_target;}
  inline That *that() {return (That*)_that;}

};


#line 25 "C:/DA/ACSTUTestCAA/PROQMFW/PROQMActions.m/src/Action3.cpp"

#line 818 "C:/DA/ACSTUTestCAA/Aspects/PROQMActions.m/src/Action3.cpp"

inline void __call__ZN7Action37executeEv_0_0 (::Action3 *srcthis, void (::Action3::* fptr)(), ::Action3 *dstthis){
  TJP__ZN7Action37executeEv_0_0 tjp;
  tjp._target =  (TJP__ZN7Action37executeEv_0_0::Target*)dstthis;
  tjp._that =  (TJP__ZN7Action37executeEv_0_0::That*)srcthis;
  AC::invoke_IndentedLogging_IndentedLogging_a0_before<TJP__ZN7Action37executeEv_0_0> (&tjp);
(dstthis->*fptr)();
  AC::invoke_IndentedLogging_IndentedLogging_a1_after<TJP__ZN7Action37executeEv_0_0> (&tjp);
 }

#line 25 "C:/DA/ACSTUTestCAA/PROQMFW/PROQMActions.m/src/Action3.cpp"

#line 831 "C:/DA/ACSTUTestCAA/Aspects/PROQMActions.m/src/Action3.cpp"

struct TJP__ZN7Action37executeEv_2_0 {
  typedef void Result;
  typedef ::Action3 That;
  typedef ::Action3 Target;
  static const int JPID = 133;
  static const AC::JPType JPTYPE = (AC::JPType)4;
  struct Res {
    typedef void Type;
    typedef void ReferredType;
  };
  enum { ARGS = 0 };
  template <int I> struct Arg {
    typedef void Type;
    typedef void ReferredType;
  };

  Target *_target;
  That *_that;

  inline static const char *signature () { return "void Action3::printface()";}
  inline Target *target() {return (Target*)_target;}
  inline That *that() {return (That*)_that;}

};


#line 25 "C:/DA/ACSTUTestCAA/PROQMFW/PROQMActions.m/src/Action3.cpp"

#line 861 "C:/DA/ACSTUTestCAA/Aspects/PROQMActions.m/src/Action3.cpp"

inline void __call__ZN7Action37executeEv_2_0 (::Action3 *srcthis, void (::Action3::* fptr)(), ::Action3 *dstthis){
  TJP__ZN7Action37executeEv_2_0 tjp;
  tjp._target =  (TJP__ZN7Action37executeEv_2_0::Target*)dstthis;
  tjp._that =  (TJP__ZN7Action37executeEv_2_0::That*)srcthis;
  AC::invoke_IndentedLogging_IndentedLogging_a0_before<TJP__ZN7Action37executeEv_2_0> (&tjp);
(dstthis->*fptr)();
  AC::invoke_IndentedLogging_IndentedLogging_a1_after<TJP__ZN7Action37executeEv_2_0> (&tjp);
 }

#line 25 "C:/DA/ACSTUTestCAA/PROQMFW/PROQMActions.m/src/Action3.cpp"

#line 874 "C:/DA/ACSTUTestCAA/Aspects/PROQMActions.m/src/Action3.cpp"

struct TJP__ZN7Action37executeEv_4_0 {
  typedef void Result;
  typedef ::Action3 That;
  typedef ::Action3 Target;
  static const int JPID = 134;
  static const AC::JPType JPTYPE = (AC::JPType)4;
  struct Res {
    typedef void Type;
    typedef void ReferredType;
  };
  enum { ARGS = 0 };
  template <int I> struct Arg {
    typedef void Type;
    typedef void ReferredType;
  };

  Target *_target;
  That *_that;

  inline static const char *signature () { return "void Action3::printface()";}
  inline Target *target() {return (Target*)_target;}
  inline That *that() {return (That*)_that;}

};


#line 25 "C:/DA/ACSTUTestCAA/PROQMFW/PROQMActions.m/src/Action3.cpp"

#line 904 "C:/DA/ACSTUTestCAA/Aspects/PROQMActions.m/src/Action3.cpp"

inline void __call__ZN7Action37executeEv_4_0 (::Action3 *srcthis, void (::Action3::* fptr)(), ::Action3 *dstthis){
  TJP__ZN7Action37executeEv_4_0 tjp;
  tjp._target =  (TJP__ZN7Action37executeEv_4_0::Target*)dstthis;
  tjp._that =  (TJP__ZN7Action37executeEv_4_0::That*)srcthis;
  AC::invoke_IndentedLogging_IndentedLogging_a0_before<TJP__ZN7Action37executeEv_4_0> (&tjp);
(dstthis->*fptr)();
  AC::invoke_IndentedLogging_IndentedLogging_a1_after<TJP__ZN7Action37executeEv_4_0> (&tjp);
 }

#line 25 "C:/DA/ACSTUTestCAA/PROQMFW/PROQMActions.m/src/Action3.cpp"

#line 917 "C:/DA/ACSTUTestCAA/Aspects/PROQMActions.m/src/Action3.cpp"

struct TJP__ZN7Action37executeEv_6_0 {
  typedef void Result;
  typedef ::Action3 That;
  typedef ::Action3 Target;
  static const int JPID = 135;
  static const AC::JPType JPTYPE = (AC::JPType)4;
  struct Res {
    typedef void Type;
    typedef void ReferredType;
  };
  enum { ARGS = 0 };
  template <int I> struct Arg {
    typedef void Type;
    typedef void ReferredType;
  };

  Target *_target;
  That *_that;

  inline static const char *signature () { return "void Action3::printface()";}
  inline Target *target() {return (Target*)_target;}
  inline That *that() {return (That*)_that;}

};


#line 25 "C:/DA/ACSTUTestCAA/PROQMFW/PROQMActions.m/src/Action3.cpp"

#line 947 "C:/DA/ACSTUTestCAA/Aspects/PROQMActions.m/src/Action3.cpp"

inline void __call__ZN7Action37executeEv_6_0 (::Action3 *srcthis, void (::Action3::* fptr)(), ::Action3 *dstthis){
  TJP__ZN7Action37executeEv_6_0 tjp;
  tjp._target =  (TJP__ZN7Action37executeEv_6_0::Target*)dstthis;
  tjp._that =  (TJP__ZN7Action37executeEv_6_0::That*)srcthis;
  AC::invoke_IndentedLogging_IndentedLogging_a0_before<TJP__ZN7Action37executeEv_6_0> (&tjp);
(dstthis->*fptr)();
  AC::invoke_IndentedLogging_IndentedLogging_a1_after<TJP__ZN7Action37executeEv_6_0> (&tjp);
 }

#line 25 "C:/DA/ACSTUTestCAA/PROQMFW/PROQMActions.m/src/Action3.cpp"

#line 960 "C:/DA/ACSTUTestCAA/Aspects/PROQMActions.m/src/Action3.cpp"

struct TJP__ZN7Action37executeEv_8_0 {
  typedef void Result;
  typedef ::Action3 That;
  typedef ::Action3 Target;
  static const int JPID = 136;
  static const AC::JPType JPTYPE = (AC::JPType)4;
  struct Res {
    typedef void Type;
    typedef void ReferredType;
  };
  enum { ARGS = 0 };
  template <int I> struct Arg {
    typedef void Type;
    typedef void ReferredType;
  };

  Target *_target;
  That *_that;

  inline static const char *signature () { return "void Action3::printface()";}
  inline Target *target() {return (Target*)_target;}
  inline That *that() {return (That*)_that;}

};


#line 25 "C:/DA/ACSTUTestCAA/PROQMFW/PROQMActions.m/src/Action3.cpp"

#line 990 "C:/DA/ACSTUTestCAA/Aspects/PROQMActions.m/src/Action3.cpp"

inline void __call__ZN7Action37executeEv_8_0 (::Action3 *srcthis, void (::Action3::* fptr)(), ::Action3 *dstthis){
  TJP__ZN7Action37executeEv_8_0 tjp;
  tjp._target =  (TJP__ZN7Action37executeEv_8_0::Target*)dstthis;
  tjp._that =  (TJP__ZN7Action37executeEv_8_0::That*)srcthis;
  AC::invoke_IndentedLogging_IndentedLogging_a0_before<TJP__ZN7Action37executeEv_8_0> (&tjp);
(dstthis->*fptr)();
  AC::invoke_IndentedLogging_IndentedLogging_a1_after<TJP__ZN7Action37executeEv_8_0> (&tjp);
 }

#line 25 "C:/DA/ACSTUTestCAA/PROQMFW/PROQMActions.m/src/Action3.cpp"

#line 1003 "C:/DA/ACSTUTestCAA/Aspects/PROQMActions.m/src/Action3.cpp"

struct TJP__ZN7Action37executeEv_10_0 {
  typedef void Result;
  typedef ::Action3 That;
  typedef ::Action3 Target;
  static const int JPID = 137;
  static const AC::JPType JPTYPE = (AC::JPType)4;
  struct Res {
    typedef void Type;
    typedef void ReferredType;
  };
  enum { ARGS = 0 };
  template <int I> struct Arg {
    typedef void Type;
    typedef void ReferredType;
  };

  Target *_target;
  That *_that;

  inline static const char *signature () { return "void Action3::printface()";}
  inline Target *target() {return (Target*)_target;}
  inline That *that() {return (That*)_that;}

};


#line 25 "C:/DA/ACSTUTestCAA/PROQMFW/PROQMActions.m/src/Action3.cpp"

#line 1033 "C:/DA/ACSTUTestCAA/Aspects/PROQMActions.m/src/Action3.cpp"

inline void __call__ZN7Action37executeEv_10_0 (::Action3 *srcthis, void (::Action3::* fptr)(), ::Action3 *dstthis){
  TJP__ZN7Action37executeEv_10_0 tjp;
  tjp._target =  (TJP__ZN7Action37executeEv_10_0::Target*)dstthis;
  tjp._that =  (TJP__ZN7Action37executeEv_10_0::That*)srcthis;
  AC::invoke_IndentedLogging_IndentedLogging_a0_before<TJP__ZN7Action37executeEv_10_0> (&tjp);
(dstthis->*fptr)();
  AC::invoke_IndentedLogging_IndentedLogging_a1_after<TJP__ZN7Action37executeEv_10_0> (&tjp);
 }

#line 25 "C:/DA/ACSTUTestCAA/PROQMFW/PROQMActions.m/src/Action3.cpp"

#line 1046 "C:/DA/ACSTUTestCAA/Aspects/PROQMActions.m/src/Action3.cpp"

struct TJP__ZN7Action37executeEv_12_0 {
  typedef void Result;
  typedef ::Action3 That;
  typedef ::Action3 Target;
  static const int JPID = 138;
  static const AC::JPType JPTYPE = (AC::JPType)4;
  struct Res {
    typedef void Type;
    typedef void ReferredType;
  };
  enum { ARGS = 0 };
  template <int I> struct Arg {
    typedef void Type;
    typedef void ReferredType;
  };

  Target *_target;
  That *_that;

  inline static const char *signature () { return "void Action3::printface()";}
  inline Target *target() {return (Target*)_target;}
  inline That *that() {return (That*)_that;}

};


#line 25 "C:/DA/ACSTUTestCAA/PROQMFW/PROQMActions.m/src/Action3.cpp"

#line 1076 "C:/DA/ACSTUTestCAA/Aspects/PROQMActions.m/src/Action3.cpp"

inline void __call__ZN7Action37executeEv_12_0 (::Action3 *srcthis, void (::Action3::* fptr)(), ::Action3 *dstthis){
  TJP__ZN7Action37executeEv_12_0 tjp;
  tjp._target =  (TJP__ZN7Action37executeEv_12_0::Target*)dstthis;
  tjp._that =  (TJP__ZN7Action37executeEv_12_0::That*)srcthis;
  AC::invoke_IndentedLogging_IndentedLogging_a0_before<TJP__ZN7Action37executeEv_12_0> (&tjp);
(dstthis->*fptr)();
  AC::invoke_IndentedLogging_IndentedLogging_a1_after<TJP__ZN7Action37executeEv_12_0> (&tjp);
 }

#line 25 "C:/DA/ACSTUTestCAA/PROQMFW/PROQMActions.m/src/Action3.cpp"

#line 1089 "C:/DA/ACSTUTestCAA/Aspects/PROQMActions.m/src/Action3.cpp"

struct TJP__ZN7Action37executeEv_14_0 {
  typedef void Result;
  typedef ::Action3 That;
  typedef ::Action3 Target;
  static const int JPID = 139;
  static const AC::JPType JPTYPE = (AC::JPType)4;
  struct Res {
    typedef void Type;
    typedef void ReferredType;
  };
  enum { ARGS = 0 };
  template <int I> struct Arg {
    typedef void Type;
    typedef void ReferredType;
  };

  Target *_target;
  That *_that;

  inline static const char *signature () { return "void Action3::printface()";}
  inline Target *target() {return (Target*)_target;}
  inline That *that() {return (That*)_that;}

};


#line 25 "C:/DA/ACSTUTestCAA/PROQMFW/PROQMActions.m/src/Action3.cpp"

#line 1119 "C:/DA/ACSTUTestCAA/Aspects/PROQMActions.m/src/Action3.cpp"

inline void __call__ZN7Action37executeEv_14_0 (::Action3 *srcthis, void (::Action3::* fptr)(), ::Action3 *dstthis){
  TJP__ZN7Action37executeEv_14_0 tjp;
  tjp._target =  (TJP__ZN7Action37executeEv_14_0::Target*)dstthis;
  tjp._that =  (TJP__ZN7Action37executeEv_14_0::That*)srcthis;
  AC::invoke_IndentedLogging_IndentedLogging_a0_before<TJP__ZN7Action37executeEv_14_0> (&tjp);
(dstthis->*fptr)();
  AC::invoke_IndentedLogging_IndentedLogging_a1_after<TJP__ZN7Action37executeEv_14_0> (&tjp);
 }

#line 25 "C:/DA/ACSTUTestCAA/PROQMFW/PROQMActions.m/src/Action3.cpp"

#line 1132 "C:/DA/ACSTUTestCAA/Aspects/PROQMActions.m/src/Action3.cpp"

struct TJP__ZN7Action37executeEv_16_0 {
  typedef void Result;
  typedef ::Action3 That;
  typedef ::Action3 Target;
  static const int JPID = 140;
  static const AC::JPType JPTYPE = (AC::JPType)4;
  struct Res {
    typedef void Type;
    typedef void ReferredType;
  };
  enum { ARGS = 0 };
  template <int I> struct Arg {
    typedef void Type;
    typedef void ReferredType;
  };

  Target *_target;
  That *_that;

  inline static const char *signature () { return "void Action3::printface()";}
  inline Target *target() {return (Target*)_target;}
  inline That *that() {return (That*)_that;}

};


#line 25 "C:/DA/ACSTUTestCAA/PROQMFW/PROQMActions.m/src/Action3.cpp"

#line 1162 "C:/DA/ACSTUTestCAA/Aspects/PROQMActions.m/src/Action3.cpp"

inline void __call__ZN7Action37executeEv_16_0 (::Action3 *srcthis, void (::Action3::* fptr)(), ::Action3 *dstthis){
  TJP__ZN7Action37executeEv_16_0 tjp;
  tjp._target =  (TJP__ZN7Action37executeEv_16_0::Target*)dstthis;
  tjp._that =  (TJP__ZN7Action37executeEv_16_0::That*)srcthis;
  AC::invoke_IndentedLogging_IndentedLogging_a0_before<TJP__ZN7Action37executeEv_16_0> (&tjp);
(dstthis->*fptr)();
  AC::invoke_IndentedLogging_IndentedLogging_a1_after<TJP__ZN7Action37executeEv_16_0> (&tjp);
 }

#line 25 "C:/DA/ACSTUTestCAA/PROQMFW/PROQMActions.m/src/Action3.cpp"

#line 1175 "C:/DA/ACSTUTestCAA/Aspects/PROQMActions.m/src/Action3.cpp"

struct TJP__ZN7Action37executeEv_18_0 {
  typedef void Result;
  typedef ::Action3 That;
  typedef ::Action3 Target;
  static const int JPID = 141;
  static const AC::JPType JPTYPE = (AC::JPType)4;
  struct Res {
    typedef void Type;
    typedef void ReferredType;
  };
  enum { ARGS = 0 };
  template <int I> struct Arg {
    typedef void Type;
    typedef void ReferredType;
  };

  Target *_target;
  That *_that;

  inline static const char *signature () { return "void Action3::printface()";}
  inline Target *target() {return (Target*)_target;}
  inline That *that() {return (That*)_that;}

};


#line 25 "C:/DA/ACSTUTestCAA/PROQMFW/PROQMActions.m/src/Action3.cpp"

#line 1205 "C:/DA/ACSTUTestCAA/Aspects/PROQMActions.m/src/Action3.cpp"

inline void __call__ZN7Action37executeEv_18_0 (::Action3 *srcthis, void (::Action3::* fptr)(), ::Action3 *dstthis){
  TJP__ZN7Action37executeEv_18_0 tjp;
  tjp._target =  (TJP__ZN7Action37executeEv_18_0::Target*)dstthis;
  tjp._that =  (TJP__ZN7Action37executeEv_18_0::That*)srcthis;
  AC::invoke_IndentedLogging_IndentedLogging_a0_before<TJP__ZN7Action37executeEv_18_0> (&tjp);
(dstthis->*fptr)();
  AC::invoke_IndentedLogging_IndentedLogging_a1_after<TJP__ZN7Action37executeEv_18_0> (&tjp);
 }

#line 25 "C:/DA/ACSTUTestCAA/PROQMFW/PROQMActions.m/src/Action3.cpp"
int Action3::execute()
{
	__call__ZN7Action37executeEv_0_0 ((::Action3*)this, &::Action3::printface,(::Action3*)this);
	__call__ZN7Action37executeEv_1_0 ((::Action3*)this,(::Action3*)this);
	__call__ZN7Action37executeEv_2_0 ((::Action3*)this, &::Action3::printface,(::Action3*)this);
	__call__ZN7Action37executeEv_3_0 ((::Action3*)this,(::Action3*)this);
	__call__ZN7Action37executeEv_4_0 ((::Action3*)this, &::Action3::printface,(::Action3*)this);
	__call__ZN7Action37executeEv_5_0 ((::Action3*)this,(::Action3*)this);
	__call__ZN7Action37executeEv_6_0 ((::Action3*)this, &::Action3::printface,(::Action3*)this);
	__call__ZN7Action37executeEv_7_0 ((::Action3*)this,(::Action3*)this);
	__call__ZN7Action37executeEv_8_0 ((::Action3*)this, &::Action3::printface,(::Action3*)this);
	__call__ZN7Action37executeEv_9_0 ((::Action3*)this,(::Action3*)this);
	__call__ZN7Action37executeEv_10_0 ((::Action3*)this, &::Action3::printface,(::Action3*)this);
	__call__ZN7Action37executeEv_11_0 ((::Action3*)this,(::Action3*)this);
	__call__ZN7Action37executeEv_12_0 ((::Action3*)this, &::Action3::printface,(::Action3*)this);
	__call__ZN7Action37executeEv_13_0 ((::Action3*)this,(::Action3*)this);
	__call__ZN7Action37executeEv_14_0 ((::Action3*)this, &::Action3::printface,(::Action3*)this);
	__call__ZN7Action37executeEv_15_0 ((::Action3*)this,(::Action3*)this);
	__call__ZN7Action37executeEv_16_0 ((::Action3*)this, &::Action3::printface,(::Action3*)this);
	__call__ZN7Action37executeEv_17_0 ((::Action3*)this,(::Action3*)this);
	__call__ZN7Action37executeEv_18_0 ((::Action3*)this, &::Action3::printface,(::Action3*)this);
	__call__ZN7Action37executeEv_19_0 ((::Action3*)this,(::Action3*)this);
	return 0;
}
 

#line 1243 "C:/DA/ACSTUTestCAA/Aspects/PROQMActions.m/src/Action3.cpp"

#ifdef __ac_FIRST_FILE_C__DA_ACSTUTestCAA_PROQMFW_PROQMActions_m_src_Action3_cpp__
/*** begin of aspect includes ***/
#if !defined(__ac_have_C__DA_ACSTUTestCAA_Aspects_ErrorHandling_ah__) && defined(__ac_need_C__DA_ACSTUTestCAA_Aspects_ErrorHandling_ah__)
#define __ac_have_C__DA_ACSTUTestCAA_Aspects_ErrorHandling_ah__
#include "C:/DA/ACSTUTestCAA/Aspects/ErrorHandling.ah"
#endif
#if !defined(__ac_have_C__DA_ACSTUTestCAA_Aspects_Profiling_ah__) && defined(__ac_need_C__DA_ACSTUTestCAA_Aspects_Profiling_ah__)
#define __ac_have_C__DA_ACSTUTestCAA_Aspects_Profiling_ah__

#line 1 "C:/DA/ACSTUTestCAA/Aspects/Profiling.ah"

#line 1256 "C:/DA/ACSTUTestCAA/Aspects/PROQMActions.m/src/Action3.cpp"

#ifndef __ac_fwd_IndentedLogging__
#define __ac_fwd_IndentedLogging__
class IndentedLogging;
namespace AC {
  template <class JoinPoint>
  inline void invoke_IndentedLogging_IndentedLogging_a0_before (JoinPoint *tjp);
  template <class JoinPoint>
  inline void invoke_IndentedLogging_IndentedLogging_a1_after (JoinPoint *tjp);
}
#endif

#ifndef __ac_need_C__DA_ACSTUTestCAA_Aspects_IndentedLogging_ah__
#define __ac_need_C__DA_ACSTUTestCAA_Aspects_IndentedLogging_ah__
#endif

#line 1 "C:/DA/ACSTUTestCAA/Aspects/Profiling.ah"
#ifndef Profiling_ah
#define Profiling_ah


#line 5 "C:/DA/ACSTUTestCAA/Aspects/Profiling.ah"
#include <windows.h>

#line 1281 "C:/DA/ACSTUTestCAA/Aspects/PROQMActions.m/src/Action3.cpp"
class ErrorHandling;
class IndentedLogging;

#line 6 "C:/DA/ACSTUTestCAA/Aspects/Profiling.ah"
class Profiling {
#line 1287 "C:/DA/ACSTUTestCAA/Aspects/PROQMActions.m/src/Action3.cpp"

public:
  static Profiling *aspectof () {
    static Profiling __instance;
    return &__instance;
  }
  static Profiling *aspectOf () {
    return aspectof ();
  }
private:

#line 6 "C:/DA/ACSTUTestCAA/Aspects/Profiling.ah"

#line 1301 "C:/DA/ACSTUTestCAA/Aspects/PROQMActions.m/src/Action3.cpp"
  friend class ::ErrorHandling;
  friend class ::IndentedLogging;

#line 6 "C:/DA/ACSTUTestCAA/Aspects/Profiling.ah"

	//do intiation of some data members
	
#line 1309 "C:/DA/ACSTUTestCAA/Aspects/PROQMActions.m/src/Action3.cpp"


struct TJP__ZN9ProfilingC1Ev_0 {
  typedef void Result;
  typedef ::Profiling That;
  typedef ::Profiling Target;
  static const int JPID = 170;
  static const AC::JPType JPTYPE = (AC::JPType)16;
  struct Res {
    typedef void Type;
    typedef void ReferredType;
  };
  enum { ARGS = 0 };
  template <int I> struct Arg {
    typedef void Type;
    typedef void ReferredType;
  };

  Target *_target;
  That *_that;

  inline static const char *signature () { return "Profiling::Profiling()";}
  inline Target *target() {return (Target*)_target;}
  inline That *that() {return (That*)_that;}

};


#line 8 "C:/DA/ACSTUTestCAA/Aspects/Profiling.ah"
Profiling () 
#line 1340 "C:/DA/ACSTUTestCAA/Aspects/PROQMActions.m/src/Action3.cpp"
{
  TJP__ZN9ProfilingC1Ev_0 tjp;
  tjp._target =  (TJP__ZN9ProfilingC1Ev_0::Target*)this;
  tjp._that =  (TJP__ZN9ProfilingC1Ev_0::That*)this;
  AC::invoke_IndentedLogging_IndentedLogging_a0_before<TJP__ZN9ProfilingC1Ev_0> (&tjp);
this->__exec_old_C1();
  AC::invoke_IndentedLogging_IndentedLogging_a1_after<TJP__ZN9ProfilingC1Ev_0> (&tjp);

}
inline void __exec_old_C1()
#line 8 "C:/DA/ACSTUTestCAA/Aspects/Profiling.ah"
{
		std::cout<<"this Profiling Profiling()"<<std::endl;

	  timeAmount=0;
	  MaximaTime=80;
  }

  public:
	
#line 16 "C:/DA/ACSTUTestCAA/Aspects/Profiling.ah"

	
#line 17 "C:/DA/ACSTUTestCAA/Aspects/Profiling.ah"


 private:
    DWORD timeAmount;
    DWORD MaximaTime;
	DWORD _dwStart;			//start time
	DWORD _dwEnd;				//end time
   	DWORD _checkpoint;		//check point time
public:
	//dont know, if it has some effect
	static Profiling *instance() {
		std::cout<<"this Profiling instance()"<<std::endl;

		static Profiling profile;
		return &profile;
	} 

	
#line 3 "C:/DA/ACSTUTestCAA/Aspects/Profiling.ah"

public: template<class JoinPoint> void __a0_before 
#line 34 "C:/DA/ACSTUTestCAA/Aspects/Profiling.ah"

#line 34 "C:/DA/ACSTUTestCAA/Aspects/Profiling.ah"
(JoinPoint *tjp)
#line 34 "C:/DA/ACSTUTestCAA/Aspects/Profiling.ah"

	{
#line 1393 "C:/DA/ACSTUTestCAA/Aspects/PROQMActions.m/src/Action3.cpp"

  typedef typename JoinPoint::That __JP_That;
  typedef typename JoinPoint::Target __JP_Target;
  typedef typename JoinPoint::Result __JP_Result;

#line 35 "C:/DA/ACSTUTestCAA/Aspects/Profiling.ah"

		//Set the start time, which should be retrieved by anthoer advice
		_dwStart = getTime();
        std::cout << "This "<<this<<std::endl;
        std::cout << "**loggedOperations _dwStart is " <<_dwStart << std::endl; 
		_dwEnd = 0;
        _checkpoint = 0;
        std::cout << "that name is " <<tjp->that()->ClassName() << std::endl;
        std::cout << "target name is " <<tjp->target()->ClassName() << std::endl;
	}
    
#line 3 "C:/DA/ACSTUTestCAA/Aspects/Profiling.ah"

public: template<class JoinPoint> void __a1_after 
#line 45 "C:/DA/ACSTUTestCAA/Aspects/Profiling.ah"

#line 45 "C:/DA/ACSTUTestCAA/Aspects/Profiling.ah"
(JoinPoint *tjp)
#line 45 "C:/DA/ACSTUTestCAA/Aspects/Profiling.ah"

    {
#line 1421 "C:/DA/ACSTUTestCAA/Aspects/PROQMActions.m/src/Action3.cpp"

  typedef typename JoinPoint::That __JP_That;
  typedef typename JoinPoint::Target __JP_Target;
  typedef typename JoinPoint::Result __JP_Result;

#line 46 "C:/DA/ACSTUTestCAA/Aspects/Profiling.ah"

        _checkpoint = getTime();
        std::cout << "This "<<this<<std::endl;
        std::cout << "**checkedOperations _dwStart is " <<_dwStart << std::endl; 
        std::cout << "target name is " <<tjp->target()->ClassName() << std::endl;
        DWORD tempvalue = _checkpoint - _dwStart;
        std::cout <<"Check point time is " << _checkpoint <<", duration " << tempvalue<< std::endl;
        if(tempvalue>MaximaTime) 
        {
			std::cout << "action exceed the maximal run time, action must be abort!!!"<<std::endl;
            throw ("Expnd Time");		
        }
    }

	
#line 3 "C:/DA/ACSTUTestCAA/Aspects/Profiling.ah"

public: template<class JoinPoint> void __a2_after 
#line 60 "C:/DA/ACSTUTestCAA/Aspects/Profiling.ah"

#line 60 "C:/DA/ACSTUTestCAA/Aspects/Profiling.ah"
(JoinPoint *tjp)
#line 60 "C:/DA/ACSTUTestCAA/Aspects/Profiling.ah"

	{
#line 1453 "C:/DA/ACSTUTestCAA/Aspects/PROQMActions.m/src/Action3.cpp"

  typedef typename JoinPoint::That __JP_That;
  typedef typename JoinPoint::Target __JP_Target;
  typedef typename JoinPoint::Result __JP_Result;

#line 61 "C:/DA/ACSTUTestCAA/Aspects/Profiling.ah"

		_dwEnd =getTime();		
		timeAmount += _dwEnd - _dwStart ;
		std::cout << "*************time span is " <<_dwEnd - _dwStart << std::endl; 
		std::cout << "*************time amount  is " <<timeAmount << std::endl; 
        std::cout << "target name is " <<tjp->target()->ClassName() << std::endl;
	}

	DWORD getTime()
	{
		DWORD tickCount = GetTickCount();
		return tickCount;
	}
	char* ClassName(){return "Profiling";}


#line 1476 "C:/DA/ACSTUTestCAA/Aspects/PROQMActions.m/src/Action3.cpp"

struct TJP__ZN9ProfilingC1ERK9Profiling_0 {
  typedef void Result;
  typedef ::Profiling That;
  typedef ::Profiling Target;
  static const int JPID = 170;
  static const AC::JPType JPTYPE = (AC::JPType)16;
  struct Res {
    typedef void Type;
    typedef void ReferredType;
  };
  enum { ARGS = 1 };
  template <int I> struct Arg {
    typedef void Type;
    typedef void ReferredType;
  };
  template <> struct Arg<0> {
    typedef const ::Profiling & Type;
    typedef const ::Profiling ReferredType;
  };

  Target *_target;
  That *_that;

  inline static const char *signature () { return "Profiling::Profiling(const Profiling &)";}
  inline Target *target() {return (Target*)_target;}
  inline That *that() {return (That*)_that;}

};


#line 76 "C:/DA/ACSTUTestCAA/Aspects/Profiling.ah"

#line 1510 "C:/DA/ACSTUTestCAA/Aspects/PROQMActions.m/src/Action3.cpp"

public:
inline Profiling (const Profiling & arg0) : timeAmount (arg0.timeAmount), MaximaTime (arg0.MaximaTime), _dwStart (arg0._dwStart), _dwEnd (arg0._dwEnd), _checkpoint (arg0._checkpoint) {
  TJP__ZN9ProfilingC1ERK9Profiling_0 tjp;
  tjp._target =  (TJP__ZN9ProfilingC1ERK9Profiling_0::Target*)this;
  tjp._that =  (TJP__ZN9ProfilingC1ERK9Profiling_0::That*)this;
  AC::invoke_IndentedLogging_IndentedLogging_a0_before<TJP__ZN9ProfilingC1ERK9Profiling_0> (&tjp);
  AC::invoke_IndentedLogging_IndentedLogging_a1_after<TJP__ZN9ProfilingC1ERK9Profiling_0> (&tjp);

}

#line 76 "C:/DA/ACSTUTestCAA/Aspects/Profiling.ah"

#line 1524 "C:/DA/ACSTUTestCAA/Aspects/PROQMActions.m/src/Action3.cpp"

struct TJP__ZN9ProfilingD1Ev_0 {
  typedef void Result;
  typedef ::Profiling That;
  typedef ::Profiling Target;
  static const int JPID = 170;
  static const AC::JPType JPTYPE = (AC::JPType)32;
  struct Res {
    typedef void Type;
    typedef void ReferredType;
  };
  enum { ARGS = 0 };
  template <int I> struct Arg {
    typedef void Type;
    typedef void ReferredType;
  };

  Target *_target;
  That *_that;

  inline static const char *signature () { return "Profiling::~Profiling()";}
  inline Target *target() {return (Target*)_target;}
  inline That *that() {return (That*)_that;}

};


#line 76 "C:/DA/ACSTUTestCAA/Aspects/Profiling.ah"

#line 1554 "C:/DA/ACSTUTestCAA/Aspects/PROQMActions.m/src/Action3.cpp"

public:
inline ~Profiling () {
  TJP__ZN9ProfilingD1Ev_0 tjp;
  tjp._target =  (TJP__ZN9ProfilingD1Ev_0::Target*)this;
  tjp._that =  (TJP__ZN9ProfilingD1Ev_0::That*)this;
  AC::invoke_IndentedLogging_IndentedLogging_a0_before<TJP__ZN9ProfilingD1Ev_0> (&tjp);
  AC::invoke_IndentedLogging_IndentedLogging_a1_after<TJP__ZN9ProfilingD1Ev_0> (&tjp);

}

#line 76 "C:/DA/ACSTUTestCAA/Aspects/Profiling.ah"
};
#line 1568 "C:/DA/ACSTUTestCAA/Aspects/PROQMActions.m/src/Action3.cpp"

namespace AC {
  template <class JoinPoint>
  inline void invoke_Profiling_Profiling_a0_before (JoinPoint *tjp) {
    ::Profiling::aspectof()->__a0_before (tjp);
  }
  template <class JoinPoint>
  inline void invoke_Profiling_Profiling_a1_after (JoinPoint *tjp) {
    ::Profiling::aspectof()->__a1_after (tjp);
  }
  template <class JoinPoint>
  inline void invoke_Profiling_Profiling_a2_after (JoinPoint *tjp) {
    ::Profiling::aspectof()->__a2_after (tjp);
  }
} 

#line 76 "C:/DA/ACSTUTestCAA/Aspects/Profiling.ah"

#endif
#line 11 "C:/DA/ACSTUTestCAA/PROQMFW/PROQMActions.m/src/Action3.cpp"
#endif
#if !defined(__ac_have_C__DA_ACSTUTestCAA_Aspects_IndentedLogging_ah__) && defined(__ac_need_C__DA_ACSTUTestCAA_Aspects_IndentedLogging_ah__)
#define __ac_have_C__DA_ACSTUTestCAA_Aspects_IndentedLogging_ah__

#line 1 "C:/DA/ACSTUTestCAA/Aspects/IndentedLogging.ah"

#line 1595 "C:/DA/ACSTUTestCAA/Aspects/PROQMActions.m/src/Action3.cpp"

#ifndef __ac_fwd_IndentedLogging__
#define __ac_fwd_IndentedLogging__
class IndentedLogging;
namespace AC {
  template <class JoinPoint>
  inline void invoke_IndentedLogging_IndentedLogging_a0_before (JoinPoint *tjp);
  template <class JoinPoint>
  inline void invoke_IndentedLogging_IndentedLogging_a1_after (JoinPoint *tjp);
}
#endif

#ifndef __ac_need_C__DA_ACSTUTestCAA_Aspects_IndentedLogging_ah__
#define __ac_need_C__DA_ACSTUTestCAA_Aspects_IndentedLogging_ah__
#endif

#line 1 "C:/DA/ACSTUTestCAA/Aspects/IndentedLogging.ah"
#ifndef IndentedLogging_ah
#define IndentedLogging_ah

#line 1 "C:/DA/ACSTUTestCAA/Aspects/IndentedLogging.ah"

#line 1618 "C:/DA/ACSTUTestCAA/Aspects/PROQMActions.m/src/Action3.cpp"
class ErrorHandling;
class Profiling;

#line 4 "C:/DA/ACSTUTestCAA/Aspects/IndentedLogging.ah"
class IndentedLogging
{
#line 1625 "C:/DA/ACSTUTestCAA/Aspects/PROQMActions.m/src/Action3.cpp"

public:
  static IndentedLogging *aspectof () {
    static IndentedLogging __instance;
    return &__instance;
  }
  static IndentedLogging *aspectOf () {
    return aspectof ();
  }
private:

#line 5 "C:/DA/ACSTUTestCAA/Aspects/IndentedLogging.ah"

#line 1639 "C:/DA/ACSTUTestCAA/Aspects/PROQMActions.m/src/Action3.cpp"
  friend class ::ErrorHandling;
  friend class ::Profiling;

#line 5 "C:/DA/ACSTUTestCAA/Aspects/IndentedLogging.ah"

private:
    void  Indentedprint(const char* sig)
    {
        for(int i = 0; i < _indentationLevel; i++)
        {
            std::cout<<"##";
        }
        std::cout<< sig<<std::endl;
    }

public:
	int _indentationLevel;
	
#line 18 "C:/DA/ACSTUTestCAA/Aspects/IndentedLogging.ah"
// && !within("IndentedLogging");// && !within("Profiling") && !within("ErrorHandling");
	//pointcut  loggedOperations()=call("% ...::%(...)") ||  construction("%") || destruction("%") && !within("IndentedLogging");// && !within("Profiling") && !within("ErrorHandling");
	
#line 1662 "C:/DA/ACSTUTestCAA/Aspects/PROQMActions.m/src/Action3.cpp"


struct TJP__ZN15IndentedLoggingC1Ev_0 {
  typedef void Result;
  typedef ::IndentedLogging That;
  typedef ::IndentedLogging Target;
  static const int JPID = 171;
  static const AC::JPType JPTYPE = (AC::JPType)16;
  struct Res {
    typedef void Type;
    typedef void ReferredType;
  };
  enum { ARGS = 0 };
  template <int I> struct Arg {
    typedef void Type;
    typedef void ReferredType;
  };

  Target *_target;
  That *_that;

  inline static const char *signature () { return "IndentedLogging::IndentedLogging()";}
  inline Target *target() {return (Target*)_target;}
  inline That *that() {return (That*)_that;}

};


#line 20 "C:/DA/ACSTUTestCAA/Aspects/IndentedLogging.ah"
IndentedLogging():_indentationLevel(0)
#line 1693 "C:/DA/ACSTUTestCAA/Aspects/PROQMActions.m/src/Action3.cpp"
{
  TJP__ZN15IndentedLoggingC1Ev_0 tjp;
  tjp._target =  (TJP__ZN15IndentedLoggingC1Ev_0::Target*)this;
  tjp._that =  (TJP__ZN15IndentedLoggingC1Ev_0::That*)this;
  AC::invoke_IndentedLogging_IndentedLogging_a0_before<TJP__ZN15IndentedLoggingC1Ev_0> (&tjp);
this->__exec_old_C1();
  AC::invoke_IndentedLogging_IndentedLogging_a1_after<TJP__ZN15IndentedLoggingC1Ev_0> (&tjp);

}
inline void __exec_old_C1()
#line 20 "C:/DA/ACSTUTestCAA/Aspects/IndentedLogging.ah"
{}
	
#line 3 "C:/DA/ACSTUTestCAA/Aspects/IndentedLogging.ah"

public: template<class JoinPoint> void __a0_before 
#line 21 "C:/DA/ACSTUTestCAA/Aspects/IndentedLogging.ah"

#line 21 "C:/DA/ACSTUTestCAA/Aspects/IndentedLogging.ah"
(JoinPoint *tjp)
#line 21 "C:/DA/ACSTUTestCAA/Aspects/IndentedLogging.ah"

	{
#line 1717 "C:/DA/ACSTUTestCAA/Aspects/PROQMActions.m/src/Action3.cpp"

  typedef typename JoinPoint::That __JP_That;
  typedef typename JoinPoint::Target __JP_Target;
  typedef typename JoinPoint::Result __JP_Result;

#line 22 "C:/DA/ACSTUTestCAA/Aspects/IndentedLogging.ah"

		_indentationLevel++;
		std::cout<<"Enter:"<<tjp->that()->ClassName()<<":"<<tjp->target()->ClassName();
		Indentedprint(tjp->signature());
	}
	
#line 3 "C:/DA/ACSTUTestCAA/Aspects/IndentedLogging.ah"

public: template<class JoinPoint> void __a1_after 
#line 27 "C:/DA/ACSTUTestCAA/Aspects/IndentedLogging.ah"

#line 27 "C:/DA/ACSTUTestCAA/Aspects/IndentedLogging.ah"
(JoinPoint *tjp)
#line 27 "C:/DA/ACSTUTestCAA/Aspects/IndentedLogging.ah"

	{
#line 1740 "C:/DA/ACSTUTestCAA/Aspects/PROQMActions.m/src/Action3.cpp"

  typedef typename JoinPoint::That __JP_That;
  typedef typename JoinPoint::Target __JP_Target;
  typedef typename JoinPoint::Result __JP_Result;

#line 28 "C:/DA/ACSTUTestCAA/Aspects/IndentedLogging.ah"

		std::cout<<"Leave:"<<tjp->that()->ClassName()<<":"<<tjp->target()->ClassName();
		Indentedprint(tjp->signature());
		_indentationLevel--;
	}
	char* ClassName(){return "IndentedLogging";}


#line 1755 "C:/DA/ACSTUTestCAA/Aspects/PROQMActions.m/src/Action3.cpp"

struct TJP__ZN15IndentedLoggingC1ERK15IndentedLogging_0 {
  typedef void Result;
  typedef ::IndentedLogging That;
  typedef ::IndentedLogging Target;
  static const int JPID = 171;
  static const AC::JPType JPTYPE = (AC::JPType)16;
  struct Res {
    typedef void Type;
    typedef void ReferredType;
  };
  enum { ARGS = 1 };
  template <int I> struct Arg {
    typedef void Type;
    typedef void ReferredType;
  };
  template <> struct Arg<0> {
    typedef const ::IndentedLogging & Type;
    typedef const ::IndentedLogging ReferredType;
  };

  Target *_target;
  That *_that;

  inline static const char *signature () { return "IndentedLogging::IndentedLogging(const IndentedLogging &)";}
  inline Target *target() {return (Target*)_target;}
  inline That *that() {return (That*)_that;}

};


#line 35 "C:/DA/ACSTUTestCAA/Aspects/IndentedLogging.ah"

#line 1789 "C:/DA/ACSTUTestCAA/Aspects/PROQMActions.m/src/Action3.cpp"

public:
inline IndentedLogging (const IndentedLogging & arg0) : _indentationLevel (arg0._indentationLevel) {
  TJP__ZN15IndentedLoggingC1ERK15IndentedLogging_0 tjp;
  tjp._target =  (TJP__ZN15IndentedLoggingC1ERK15IndentedLogging_0::Target*)this;
  tjp._that =  (TJP__ZN15IndentedLoggingC1ERK15IndentedLogging_0::That*)this;
  AC::invoke_IndentedLogging_IndentedLogging_a0_before<TJP__ZN15IndentedLoggingC1ERK15IndentedLogging_0> (&tjp);
  AC::invoke_IndentedLogging_IndentedLogging_a1_after<TJP__ZN15IndentedLoggingC1ERK15IndentedLogging_0> (&tjp);

}

#line 35 "C:/DA/ACSTUTestCAA/Aspects/IndentedLogging.ah"

#line 1803 "C:/DA/ACSTUTestCAA/Aspects/PROQMActions.m/src/Action3.cpp"

struct TJP__ZN15IndentedLoggingD1Ev_0 {
  typedef void Result;
  typedef ::IndentedLogging That;
  typedef ::IndentedLogging Target;
  static const int JPID = 171;
  static const AC::JPType JPTYPE = (AC::JPType)32;
  struct Res {
    typedef void Type;
    typedef void ReferredType;
  };
  enum { ARGS = 0 };
  template <int I> struct Arg {
    typedef void Type;
    typedef void ReferredType;
  };

  Target *_target;
  That *_that;

  inline static const char *signature () { return "IndentedLogging::~IndentedLogging()";}
  inline Target *target() {return (Target*)_target;}
  inline That *that() {return (That*)_that;}

};


#line 35 "C:/DA/ACSTUTestCAA/Aspects/IndentedLogging.ah"

#line 1833 "C:/DA/ACSTUTestCAA/Aspects/PROQMActions.m/src/Action3.cpp"

public:
inline ~IndentedLogging () {
  TJP__ZN15IndentedLoggingD1Ev_0 tjp;
  tjp._target =  (TJP__ZN15IndentedLoggingD1Ev_0::Target*)this;
  tjp._that =  (TJP__ZN15IndentedLoggingD1Ev_0::That*)this;
  AC::invoke_IndentedLogging_IndentedLogging_a0_before<TJP__ZN15IndentedLoggingD1Ev_0> (&tjp);
  AC::invoke_IndentedLogging_IndentedLogging_a1_after<TJP__ZN15IndentedLoggingD1Ev_0> (&tjp);

}

#line 35 "C:/DA/ACSTUTestCAA/Aspects/IndentedLogging.ah"
};
#line 1847 "C:/DA/ACSTUTestCAA/Aspects/PROQMActions.m/src/Action3.cpp"

namespace AC {
  template <class JoinPoint>
  inline void invoke_IndentedLogging_IndentedLogging_a0_before (JoinPoint *tjp) {
    ::IndentedLogging::aspectof()->__a0_before (tjp);
  }
  template <class JoinPoint>
  inline void invoke_IndentedLogging_IndentedLogging_a1_after (JoinPoint *tjp) {
    ::IndentedLogging::aspectof()->__a1_after (tjp);
  }
} 

#line 35 "C:/DA/ACSTUTestCAA/Aspects/IndentedLogging.ah"

#endif

#line 15 "C:/DA/ACSTUTestCAA/PROQMFW/PROQMActions.m/src/Action3.cpp"
#endif
/*** end of aspect includes ***/
#undef __ac_FIRST_C__DA_ACSTUTestCAA__
#undef __ac_FIRST_FILE_C__DA_ACSTUTestCAA_PROQMFW_PROQMActions_m_src_Action3_cpp__
#endif // __ac_FIRST_FILE_C__DA_ACSTUTestCAA_PROQMFW_PROQMActions_m_src_Action3_cpp__
