#include "C:/Programme/pure-systems/AspectC++ Add-In/include/vsbasics.h"

#line 1 "C:/DA/ACSTUTestCAA/PROQMFW/PROQMFramework.m/src/ActionMng.cpp"
#ifndef __ac_FIRST_C__DA_ACSTUTestCAA__
#define __ac_FIRST_C__DA_ACSTUTestCAA__
#define __ac_FIRST_FILE_C__DA_ACSTUTestCAA_PROQMFW_PROQMFramework_m_src_ActionMng_cpp__
#endif // __ac_FIRST_C__DA_ACSTUTestCAA__

#line 1 "C:/DA/ACSTUTestCAA/PROQMFW/PROQMFramework.m/src/ActionMng.cpp"

#line 12 "C:/DA/ACSTUTestCAA/Aspects/PROQMFramework.m/src/ActionMng.cpp"

#ifndef __ac_h_
#define __ac_h_
namespace AC {
  typedef const char* Type;
  enum JPType { CALL = 0x0004, EXECUTION = 0x0008, CONSTRUCTION = 0x0010, DESTRUCTION = 0x0020 };
  struct Action {
    void **_args; void *_result; void *_target; void *_that; void *_fptr;
    void (*_wrapper)(Action &);
    inline void trigger () { _wrapper (*this); }
  };
  struct AnyResultBuffer {};
  template <typename T> struct ResultBuffer : public AnyResultBuffer {
    char _data[sizeof (T)];
    ~ResultBuffer () { ((T*)_data)->T::~T(); }
    operator T& () const { return *(T*)_data; }
  };
  template <class Aspect, int Index>
  struct CFlow {
    static int &instance () {
      static int counter = 0;
      return counter;
    }
    CFlow () { instance ()++; }
    ~CFlow () { instance ()--; }
    static bool active () { return instance () > 0; }
  };
}
inline void * operator new (unsigned int, AC::AnyResultBuffer *p) { return p; }
inline void operator delete (void *, AC::AnyResultBuffer *) { } // for VC++
#endif // __ac_h_

#line 1 "C:/DA/ACSTUTestCAA/PROQMFW/PROQMFramework.m/src/ActionMng.cpp"

#line 1 "C:/DA/ACSTUTestCAA/PROQMFW/PROQMFramework.m/src/ActionMng.cpp"

#line 49 "C:/DA/ACSTUTestCAA/Aspects/PROQMFramework.m/src/ActionMng.cpp"

#ifndef __ac_fwd_ErrorHandling__
#define __ac_fwd_ErrorHandling__
class ErrorHandling;
namespace AC {
  template <class JoinPoint>
  inline void invoke_ErrorHandling_ErrorHandling_a0_around (JoinPoint *tjp);
}
#endif

#ifndef __ac_need_C__DA_ACSTUTestCAA_Aspects_ErrorHandling_ah__
#define __ac_need_C__DA_ACSTUTestCAA_Aspects_ErrorHandling_ah__
#endif

#ifndef __ac_fwd_Profiling__
#define __ac_fwd_Profiling__
class Profiling;
namespace AC {
  template <class JoinPoint>
  inline void invoke_Profiling_Profiling_a0_before (JoinPoint *tjp);
  template <class JoinPoint>
  inline void invoke_Profiling_Profiling_a1_after (JoinPoint *tjp);
  template <class JoinPoint>
  inline void invoke_Profiling_Profiling_a2_after (JoinPoint *tjp);
}
#endif

#ifndef __ac_need_C__DA_ACSTUTestCAA_Aspects_Profiling_ah__
#define __ac_need_C__DA_ACSTUTestCAA_Aspects_Profiling_ah__
#endif

#ifndef __ac_fwd_IndentedLogging__
#define __ac_fwd_IndentedLogging__
class IndentedLogging;
namespace AC {
  template <class JoinPoint>
  inline void invoke_IndentedLogging_IndentedLogging_a0_before (JoinPoint *tjp);
  template <class JoinPoint>
  inline void invoke_IndentedLogging_IndentedLogging_a1_after (JoinPoint *tjp);
}
#endif

#ifndef __ac_need_C__DA_ACSTUTestCAA_Aspects_IndentedLogging_ah__
#define __ac_need_C__DA_ACSTUTestCAA_Aspects_IndentedLogging_ah__
#endif

#line 1 "C:/DA/ACSTUTestCAA/PROQMFW/PROQMFramework.m/src/ActionMng.cpp"
#ifndef OS
#define OS Windows_NT
#endif
#ifndef _WINDOWS_SOURCE
#define _WINDOWS_SOURCE Windows_NT
#define __PROQMFramework
#endif


#line 1 "C:/DA/ACSTUTestCAA/PROQMFW/ProtectedInterfaces/ActionMng.h"

#line 108 "C:/DA/ACSTUTestCAA/Aspects/PROQMFramework.m/src/ActionMng.cpp"

#ifndef __ac_fwd_IndentedLogging__
#define __ac_fwd_IndentedLogging__
class IndentedLogging;
namespace AC {
  template <class JoinPoint>
  inline void invoke_IndentedLogging_IndentedLogging_a0_before (JoinPoint *tjp);
  template <class JoinPoint>
  inline void invoke_IndentedLogging_IndentedLogging_a1_after (JoinPoint *tjp);
}
#endif

#ifndef __ac_need_C__DA_ACSTUTestCAA_Aspects_IndentedLogging_ah__
#define __ac_need_C__DA_ACSTUTestCAA_Aspects_IndentedLogging_ah__
#endif

#line 1 "C:/DA/ACSTUTestCAA/PROQMFW/ProtectedInterfaces/ActionMng.h"
#ifndef ActionMng_H
#define ActionMng_H

#line 1 "C:/DA/ACSTUTestCAA/PROQMFW/PublicInterfaces/PROQMFramework.h"
#ifdef  _WINDOWS_SOURCE
#ifdef  __PROQMFramework
#define ExportedByPROQMFramework     __declspec(dllexport)
#else
#define ExportedByPROQMFramework     __declspec(dllimport)
#endif
#else
#define ExportedByPROQMFramework
#endif

#line 4 "C:/DA/ACSTUTestCAA/PROQMFW/ProtectedInterfaces/ActionMng.h"
#include <iostream>

#line 143 "C:/DA/ACSTUTestCAA/Aspects/PROQMFramework.m/src/ActionMng.cpp"
class ErrorHandling;
class Profiling;
class IndentedLogging;

#line 5 "C:/DA/ACSTUTestCAA/PROQMFW/ProtectedInterfaces/ActionMng.h"
class ExportedByPROQMFramework ActionMng
{
#line 151 "C:/DA/ACSTUTestCAA/Aspects/PROQMFramework.m/src/ActionMng.cpp"
  friend class ::ErrorHandling;
  friend class ::Profiling;
  friend class ::IndentedLogging;

#line 6 "C:/DA/ACSTUTestCAA/PROQMFW/ProtectedInterfaces/ActionMng.h"

  public:
	  
#line 160 "C:/DA/ACSTUTestCAA/Aspects/PROQMFramework.m/src/ActionMng.cpp"


struct TJP__ZN9ActionMngC1Ev_0 {
  typedef void Result;
  typedef ::ActionMng That;
  typedef ::ActionMng Target;
  static const int JPID = 196;
  static const AC::JPType JPTYPE = (AC::JPType)16;
  struct Res {
    typedef void Type;
    typedef void ReferredType;
  };
  enum { ARGS = 0 };
  template <int I> struct Arg {
    typedef void Type;
    typedef void ReferredType;
  };

  Target *_target;
  That *_that;

  inline static const char *signature () { return "ActionMng::ActionMng()";}
  inline Target *target() {return (Target*)_target;}
  inline That *that() {return (That*)_that;}

};


#line 8 "C:/DA/ACSTUTestCAA/PROQMFW/ProtectedInterfaces/ActionMng.h"
ActionMng ()
#line 191 "C:/DA/ACSTUTestCAA/Aspects/PROQMFramework.m/src/ActionMng.cpp"
{
  TJP__ZN9ActionMngC1Ev_0 tjp;
  tjp._target =  (TJP__ZN9ActionMngC1Ev_0::Target*)this;
  tjp._that =  (TJP__ZN9ActionMngC1Ev_0::That*)this;
  AC::invoke_IndentedLogging_IndentedLogging_a0_before<TJP__ZN9ActionMngC1Ev_0> (&tjp);
this->__exec_old_C1();
  AC::invoke_IndentedLogging_IndentedLogging_a1_after<TJP__ZN9ActionMngC1Ev_0> (&tjp);

}
inline void __exec_old_C1()
#line 8 "C:/DA/ACSTUTestCAA/PROQMFW/ProtectedInterfaces/ActionMng.h"
{
	  
#ifdef _WINDOWS_SOURCE
	std::cout<<"_WINDOWS_SOURCE defined"<<std::endl;
#else
	std::cout<<"_WINDOWS_SOURCE not defined"<<std::endl;
#endif
#ifdef __PROQMFramework
	std::cout<<"__PROQMFramework defined"<<std::endl;
#else
	std::cout<<"__PROQMFramework not defined"<<std::endl;
#endif
	std::cout <<"ActionMng::ActionMng()"<<std::endl;
	  };
	  
#line 218 "C:/DA/ACSTUTestCAA/Aspects/PROQMFramework.m/src/ActionMng.cpp"


struct TJP__ZN9ActionMngD1Ev_0 {
  typedef void Result;
  typedef ::ActionMng That;
  typedef ::ActionMng Target;
  static const int JPID = 196;
  static const AC::JPType JPTYPE = (AC::JPType)32;
  struct Res {
    typedef void Type;
    typedef void ReferredType;
  };
  enum { ARGS = 0 };
  template <int I> struct Arg {
    typedef void Type;
    typedef void ReferredType;
  };

  Target *_target;
  That *_that;

  inline static const char *signature () { return "ActionMng::~ActionMng()";}
  inline Target *target() {return (Target*)_target;}
  inline That *that() {return (That*)_that;}

};


#line 22 "C:/DA/ACSTUTestCAA/PROQMFW/ProtectedInterfaces/ActionMng.h"
virtual ~ActionMng ()
#line 249 "C:/DA/ACSTUTestCAA/Aspects/PROQMFramework.m/src/ActionMng.cpp"
{
  TJP__ZN9ActionMngD1Ev_0 tjp;
  tjp._target =  (TJP__ZN9ActionMngD1Ev_0::Target*)this;
  tjp._that =  (TJP__ZN9ActionMngD1Ev_0::That*)this;
  AC::invoke_IndentedLogging_IndentedLogging_a0_before<TJP__ZN9ActionMngD1Ev_0> (&tjp);
this->__exec_old_D1();
  AC::invoke_IndentedLogging_IndentedLogging_a1_after<TJP__ZN9ActionMngD1Ev_0> (&tjp);

}
inline void __exec_old_D1()
#line 22 "C:/DA/ACSTUTestCAA/PROQMFW/ProtectedInterfaces/ActionMng.h"
{	
		  std::cout <<"virtual ActionMng::~ActionMng()"<<std::endl;
	};
	int executeActions();
	char* ClassName(){return "ActionMng";}

#line 267 "C:/DA/ACSTUTestCAA/Aspects/PROQMFramework.m/src/ActionMng.cpp"

struct TJP__ZN9ActionMngC1ERK9ActionMng_0 {
  typedef void Result;
  typedef ::ActionMng That;
  typedef ::ActionMng Target;
  static const int JPID = 196;
  static const AC::JPType JPTYPE = (AC::JPType)16;
  struct Res {
    typedef void Type;
    typedef void ReferredType;
  };
  enum { ARGS = 1 };
  template <int I> struct Arg {
    typedef void Type;
    typedef void ReferredType;
  };
  template <> struct Arg<0> {
    typedef const ::ActionMng & Type;
    typedef const ::ActionMng ReferredType;
  };

  Target *_target;
  That *_that;

  inline static const char *signature () { return "ActionMng::ActionMng(const ActionMng &)";}
  inline Target *target() {return (Target*)_target;}
  inline That *that() {return (That*)_that;}

};


#line 27 "C:/DA/ACSTUTestCAA/PROQMFW/ProtectedInterfaces/ActionMng.h"

#line 301 "C:/DA/ACSTUTestCAA/Aspects/PROQMFramework.m/src/ActionMng.cpp"

public:
inline ActionMng (const ActionMng & arg0)  {
  TJP__ZN9ActionMngC1ERK9ActionMng_0 tjp;
  tjp._target =  (TJP__ZN9ActionMngC1ERK9ActionMng_0::Target*)this;
  tjp._that =  (TJP__ZN9ActionMngC1ERK9ActionMng_0::That*)this;
  AC::invoke_IndentedLogging_IndentedLogging_a0_before<TJP__ZN9ActionMngC1ERK9ActionMng_0> (&tjp);
  AC::invoke_IndentedLogging_IndentedLogging_a1_after<TJP__ZN9ActionMngC1ERK9ActionMng_0> (&tjp);

}

#line 27 "C:/DA/ACSTUTestCAA/PROQMFW/ProtectedInterfaces/ActionMng.h"
};
#endif

#line 1 "C:/DA/ACSTUTestCAA/PROQMFW/ProtectedInterfaces/Action1.h"

#line 319 "C:/DA/ACSTUTestCAA/Aspects/PROQMFramework.m/src/ActionMng.cpp"

#ifndef __ac_fwd_IndentedLogging__
#define __ac_fwd_IndentedLogging__
class IndentedLogging;
namespace AC {
  template <class JoinPoint>
  inline void invoke_IndentedLogging_IndentedLogging_a0_before (JoinPoint *tjp);
  template <class JoinPoint>
  inline void invoke_IndentedLogging_IndentedLogging_a1_after (JoinPoint *tjp);
}
#endif

#ifndef __ac_need_C__DA_ACSTUTestCAA_Aspects_IndentedLogging_ah__
#define __ac_need_C__DA_ACSTUTestCAA_Aspects_IndentedLogging_ah__
#endif

#line 1 "C:/DA/ACSTUTestCAA/PROQMFW/ProtectedInterfaces/Action1.h"
#ifndef Action1_H
#define Action1_H

#line 1 "C:/DA/ACSTUTestCAA/PROQMFW/PublicInterfaces/PROQMActions.h"
#ifdef  _WINDOWS_SOURCE
#ifdef  __PROQMActions
#define ExportedByPROQMActions     __declspec(dllexport)
#else
#define ExportedByPROQMActions     __declspec(dllimport)
#endif
#else
#define ExportedByPROQMActions
#endif

#line 1 "C:/DA/ACSTUTestCAA/PROQMFW/ProtectedInterfaces/Action1.h"

#line 353 "C:/DA/ACSTUTestCAA/Aspects/PROQMFramework.m/src/ActionMng.cpp"
class ErrorHandling;
class Profiling;
class IndentedLogging;

#line 6 "C:/DA/ACSTUTestCAA/PROQMFW/ProtectedInterfaces/Action1.h"
class ExportedByPROQMActions Action1
{
#line 361 "C:/DA/ACSTUTestCAA/Aspects/PROQMFramework.m/src/ActionMng.cpp"
  friend class ::ErrorHandling;
  friend class ::Profiling;
  friend class ::IndentedLogging;

#line 7 "C:/DA/ACSTUTestCAA/PROQMFW/ProtectedInterfaces/Action1.h"

  public:
	  
#line 370 "C:/DA/ACSTUTestCAA/Aspects/PROQMFramework.m/src/ActionMng.cpp"


struct TJP__ZN7Action1C1Ev_0 {
  typedef void Result;
  typedef ::Action1 That;
  typedef ::Action1 Target;
  static const int JPID = 197;
  static const AC::JPType JPTYPE = (AC::JPType)16;
  struct Res {
    typedef void Type;
    typedef void ReferredType;
  };
  enum { ARGS = 0 };
  template <int I> struct Arg {
    typedef void Type;
    typedef void ReferredType;
  };

  Target *_target;
  That *_that;

  inline static const char *signature () { return "Action1::Action1()";}
  inline Target *target() {return (Target*)_target;}
  inline That *that() {return (That*)_that;}

};


#line 9 "C:/DA/ACSTUTestCAA/PROQMFW/ProtectedInterfaces/Action1.h"
Action1 ()
#line 401 "C:/DA/ACSTUTestCAA/Aspects/PROQMFramework.m/src/ActionMng.cpp"
{
  TJP__ZN7Action1C1Ev_0 tjp;
  tjp._target =  (TJP__ZN7Action1C1Ev_0::Target*)this;
  tjp._that =  (TJP__ZN7Action1C1Ev_0::That*)this;
  AC::invoke_IndentedLogging_IndentedLogging_a0_before<TJP__ZN7Action1C1Ev_0> (&tjp);
this->__exec_old_C1();
  AC::invoke_IndentedLogging_IndentedLogging_a1_after<TJP__ZN7Action1C1Ev_0> (&tjp);

}
inline void __exec_old_C1()
#line 9 "C:/DA/ACSTUTestCAA/PROQMFW/ProtectedInterfaces/Action1.h"
{
	  
#ifdef _WINDOWS_SOURCE
	std::cout<<"_WINDOWS_SOURCE defined"<<std::endl;
#else
	std::cout<<"_WINDOWS_SOURCE not defined"<<std::endl;
#endif
#ifdef __PROQMActions
	std::cout<<"__PROQMActions defined"<<std::endl;
#else
	std::cout<<"__PROQMActions not defined"<<std::endl;
#endif
		std::cout<<"Action1::Action1()"<<std::endl;
	  }
	  
#line 428 "C:/DA/ACSTUTestCAA/Aspects/PROQMFramework.m/src/ActionMng.cpp"


struct TJP__ZN7Action1D1Ev_0 {
  typedef void Result;
  typedef ::Action1 That;
  typedef ::Action1 Target;
  static const int JPID = 197;
  static const AC::JPType JPTYPE = (AC::JPType)32;
  struct Res {
    typedef void Type;
    typedef void ReferredType;
  };
  enum { ARGS = 0 };
  template <int I> struct Arg {
    typedef void Type;
    typedef void ReferredType;
  };

  Target *_target;
  That *_that;

  inline static const char *signature () { return "Action1::~Action1()";}
  inline Target *target() {return (Target*)_target;}
  inline That *that() {return (That*)_that;}

};


#line 23 "C:/DA/ACSTUTestCAA/PROQMFW/ProtectedInterfaces/Action1.h"
virtual ~Action1 ()
#line 459 "C:/DA/ACSTUTestCAA/Aspects/PROQMFramework.m/src/ActionMng.cpp"
{
  TJP__ZN7Action1D1Ev_0 tjp;
  tjp._target =  (TJP__ZN7Action1D1Ev_0::Target*)this;
  tjp._that =  (TJP__ZN7Action1D1Ev_0::That*)this;
  AC::invoke_IndentedLogging_IndentedLogging_a0_before<TJP__ZN7Action1D1Ev_0> (&tjp);
this->__exec_old_D1();
  AC::invoke_IndentedLogging_IndentedLogging_a1_after<TJP__ZN7Action1D1Ev_0> (&tjp);

}
inline void __exec_old_D1()
#line 23 "C:/DA/ACSTUTestCAA/PROQMFW/ProtectedInterfaces/Action1.h"
{
	  	std::cout<<"virtual Action1::~Action1()"<<std::endl;
	  }
	
#line 475 "C:/DA/ACSTUTestCAA/Aspects/PROQMFramework.m/src/ActionMng.cpp"


struct TJP__ZN7Action1C1ER7Action1_0 {
  typedef void Result;
  typedef ::Action1 That;
  typedef ::Action1 Target;
  static const int JPID = 197;
  static const AC::JPType JPTYPE = (AC::JPType)16;
  struct Res {
    typedef void Type;
    typedef void ReferredType;
  };
  enum { ARGS = 1 };
  template <int I> struct Arg {
    typedef void Type;
    typedef void ReferredType;
  };
  template <> struct Arg<0> {
    typedef ::Action1 & Type;
    typedef ::Action1 ReferredType;
  };

  Target *_target;
  That *_that;

  inline static const char *signature () { return "Action1::Action1(Action1 &)";}
  inline Target *target() {return (Target*)_target;}
  inline That *that() {return (That*)_that;}

};


#line 26 "C:/DA/ACSTUTestCAA/PROQMFW/ProtectedInterfaces/Action1.h"
Action1(Action1&  arg0)
#line 510 "C:/DA/ACSTUTestCAA/Aspects/PROQMFramework.m/src/ActionMng.cpp"
{
  TJP__ZN7Action1C1ER7Action1_0 tjp;
  tjp._target =  (TJP__ZN7Action1C1ER7Action1_0::Target*)this;
  tjp._that =  (TJP__ZN7Action1C1ER7Action1_0::That*)this;
  AC::invoke_IndentedLogging_IndentedLogging_a0_before<TJP__ZN7Action1C1ER7Action1_0> (&tjp);
this->__exec_old_C1(arg0);
  AC::invoke_IndentedLogging_IndentedLogging_a1_after<TJP__ZN7Action1C1ER7Action1_0> (&tjp);

}
inline void __exec_old_C1(::Action1 & original)
#line 26 "C:/DA/ACSTUTestCAA/PROQMFW/ProtectedInterfaces/Action1.h"
{}
	Action1& operator=(Action1& original){return *this;}

	int execute();
	int checkpoint();
	char* ClassName(){return "Action1";}
private:
	void printface();

};
#endif

#line 1 "C:/DA/ACSTUTestCAA/PROQMFW/ProtectedInterfaces/Action2.h"

#line 536 "C:/DA/ACSTUTestCAA/Aspects/PROQMFramework.m/src/ActionMng.cpp"

#ifndef __ac_fwd_IndentedLogging__
#define __ac_fwd_IndentedLogging__
class IndentedLogging;
namespace AC {
  template <class JoinPoint>
  inline void invoke_IndentedLogging_IndentedLogging_a0_before (JoinPoint *tjp);
  template <class JoinPoint>
  inline void invoke_IndentedLogging_IndentedLogging_a1_after (JoinPoint *tjp);
}
#endif

#ifndef __ac_need_C__DA_ACSTUTestCAA_Aspects_IndentedLogging_ah__
#define __ac_need_C__DA_ACSTUTestCAA_Aspects_IndentedLogging_ah__
#endif

#line 1 "C:/DA/ACSTUTestCAA/PROQMFW/ProtectedInterfaces/Action2.h"
#ifndef Action2_H
#define Action2_H

#line 1 "C:/DA/ACSTUTestCAA/PROQMFW/PublicInterfaces/PROQMActions.h"
#ifdef  _WINDOWS_SOURCE
#ifdef  __PROQMActions
#define ExportedByPROQMActions     __declspec(dllexport)
#else
#define ExportedByPROQMActions     __declspec(dllimport)
#endif
#else
#define ExportedByPROQMActions
#endif

#line 1 "C:/DA/ACSTUTestCAA/PROQMFW/ProtectedInterfaces/Action2.h"

#line 570 "C:/DA/ACSTUTestCAA/Aspects/PROQMFramework.m/src/ActionMng.cpp"
class ErrorHandling;
class Profiling;
class IndentedLogging;

#line 6 "C:/DA/ACSTUTestCAA/PROQMFW/ProtectedInterfaces/Action2.h"
class ExportedByPROQMActions Action2
{
#line 578 "C:/DA/ACSTUTestCAA/Aspects/PROQMFramework.m/src/ActionMng.cpp"
  friend class ::ErrorHandling;
  friend class ::Profiling;
  friend class ::IndentedLogging;

#line 7 "C:/DA/ACSTUTestCAA/PROQMFW/ProtectedInterfaces/Action2.h"

  public:
	  
#line 587 "C:/DA/ACSTUTestCAA/Aspects/PROQMFramework.m/src/ActionMng.cpp"


struct TJP__ZN7Action2C1Ev_0 {
  typedef void Result;
  typedef ::Action2 That;
  typedef ::Action2 Target;
  static const int JPID = 198;
  static const AC::JPType JPTYPE = (AC::JPType)16;
  struct Res {
    typedef void Type;
    typedef void ReferredType;
  };
  enum { ARGS = 0 };
  template <int I> struct Arg {
    typedef void Type;
    typedef void ReferredType;
  };

  Target *_target;
  That *_that;

  inline static const char *signature () { return "Action2::Action2()";}
  inline Target *target() {return (Target*)_target;}
  inline That *that() {return (That*)_that;}

};


#line 9 "C:/DA/ACSTUTestCAA/PROQMFW/ProtectedInterfaces/Action2.h"
Action2 ()
#line 618 "C:/DA/ACSTUTestCAA/Aspects/PROQMFramework.m/src/ActionMng.cpp"
{
  TJP__ZN7Action2C1Ev_0 tjp;
  tjp._target =  (TJP__ZN7Action2C1Ev_0::Target*)this;
  tjp._that =  (TJP__ZN7Action2C1Ev_0::That*)this;
  AC::invoke_IndentedLogging_IndentedLogging_a0_before<TJP__ZN7Action2C1Ev_0> (&tjp);
this->__exec_old_C1();
  AC::invoke_IndentedLogging_IndentedLogging_a1_after<TJP__ZN7Action2C1Ev_0> (&tjp);

}
inline void __exec_old_C1()
#line 9 "C:/DA/ACSTUTestCAA/PROQMFW/ProtectedInterfaces/Action2.h"
{
#ifdef _WINDOWS_SOURCE
	std::cout<<"_WINDOWS_SOURCE defined"<<std::endl;
#else
	std::cout<<"_WINDOWS_SOURCE not defined"<<std::endl;
#endif
#ifdef __PROQMActions
	std::cout<<"__PROQMActions defined"<<std::endl;
#else
	std::cout<<"__PROQMActions not defined"<<std::endl;
#endif
		std::cout<<"Action2::Action2()"<<std::endl;
	  }
	  
#line 644 "C:/DA/ACSTUTestCAA/Aspects/PROQMFramework.m/src/ActionMng.cpp"


struct TJP__ZN7Action2D1Ev_0 {
  typedef void Result;
  typedef ::Action2 That;
  typedef ::Action2 Target;
  static const int JPID = 198;
  static const AC::JPType JPTYPE = (AC::JPType)32;
  struct Res {
    typedef void Type;
    typedef void ReferredType;
  };
  enum { ARGS = 0 };
  template <int I> struct Arg {
    typedef void Type;
    typedef void ReferredType;
  };

  Target *_target;
  That *_that;

  inline static const char *signature () { return "Action2::~Action2()";}
  inline Target *target() {return (Target*)_target;}
  inline That *that() {return (That*)_that;}

};


#line 22 "C:/DA/ACSTUTestCAA/PROQMFW/ProtectedInterfaces/Action2.h"
virtual ~Action2 ()
#line 675 "C:/DA/ACSTUTestCAA/Aspects/PROQMFramework.m/src/ActionMng.cpp"
{
  TJP__ZN7Action2D1Ev_0 tjp;
  tjp._target =  (TJP__ZN7Action2D1Ev_0::Target*)this;
  tjp._that =  (TJP__ZN7Action2D1Ev_0::That*)this;
  AC::invoke_IndentedLogging_IndentedLogging_a0_before<TJP__ZN7Action2D1Ev_0> (&tjp);
this->__exec_old_D1();
  AC::invoke_IndentedLogging_IndentedLogging_a1_after<TJP__ZN7Action2D1Ev_0> (&tjp);

}
inline void __exec_old_D1()
#line 22 "C:/DA/ACSTUTestCAA/PROQMFW/ProtectedInterfaces/Action2.h"
{
	  	std::cout<<"virtual Action2::~Action2()"<<std::endl;
	}
	
#line 691 "C:/DA/ACSTUTestCAA/Aspects/PROQMFramework.m/src/ActionMng.cpp"


struct TJP__ZN7Action2C1ER7Action2_0 {
  typedef void Result;
  typedef ::Action2 That;
  typedef ::Action2 Target;
  static const int JPID = 198;
  static const AC::JPType JPTYPE = (AC::JPType)16;
  struct Res {
    typedef void Type;
    typedef void ReferredType;
  };
  enum { ARGS = 1 };
  template <int I> struct Arg {
    typedef void Type;
    typedef void ReferredType;
  };
  template <> struct Arg<0> {
    typedef ::Action2 & Type;
    typedef ::Action2 ReferredType;
  };

  Target *_target;
  That *_that;

  inline static const char *signature () { return "Action2::Action2(Action2 &)";}
  inline Target *target() {return (Target*)_target;}
  inline That *that() {return (That*)_that;}

};


#line 25 "C:/DA/ACSTUTestCAA/PROQMFW/ProtectedInterfaces/Action2.h"
Action2(Action2&  arg0)
#line 726 "C:/DA/ACSTUTestCAA/Aspects/PROQMFramework.m/src/ActionMng.cpp"
{
  TJP__ZN7Action2C1ER7Action2_0 tjp;
  tjp._target =  (TJP__ZN7Action2C1ER7Action2_0::Target*)this;
  tjp._that =  (TJP__ZN7Action2C1ER7Action2_0::That*)this;
  AC::invoke_IndentedLogging_IndentedLogging_a0_before<TJP__ZN7Action2C1ER7Action2_0> (&tjp);
this->__exec_old_C1(arg0);
  AC::invoke_IndentedLogging_IndentedLogging_a1_after<TJP__ZN7Action2C1ER7Action2_0> (&tjp);

}
inline void __exec_old_C1(::Action2 & original)
#line 25 "C:/DA/ACSTUTestCAA/PROQMFW/ProtectedInterfaces/Action2.h"
{}
	Action2& operator=(Action2& original){return *this;}

	int execute();
	int checkpoint();
	char* ClassName(){return "Action2";}
private:
	void printface();

};
#endif

#line 1 "C:/DA/ACSTUTestCAA/PROQMFW/ProtectedInterfaces/Action3.h"

#line 752 "C:/DA/ACSTUTestCAA/Aspects/PROQMFramework.m/src/ActionMng.cpp"

#ifndef __ac_fwd_IndentedLogging__
#define __ac_fwd_IndentedLogging__
class IndentedLogging;
namespace AC {
  template <class JoinPoint>
  inline void invoke_IndentedLogging_IndentedLogging_a0_before (JoinPoint *tjp);
  template <class JoinPoint>
  inline void invoke_IndentedLogging_IndentedLogging_a1_after (JoinPoint *tjp);
}
#endif

#ifndef __ac_need_C__DA_ACSTUTestCAA_Aspects_IndentedLogging_ah__
#define __ac_need_C__DA_ACSTUTestCAA_Aspects_IndentedLogging_ah__
#endif

#line 1 "C:/DA/ACSTUTestCAA/PROQMFW/ProtectedInterfaces/Action3.h"
#ifndef Action3_H
#define Action3_H

#line 1 "C:/DA/ACSTUTestCAA/PROQMFW/PublicInterfaces/PROQMActions.h"
#ifdef  _WINDOWS_SOURCE
#ifdef  __PROQMActions
#define ExportedByPROQMActions     __declspec(dllexport)
#else
#define ExportedByPROQMActions     __declspec(dllimport)
#endif
#else
#define ExportedByPROQMActions
#endif

#line 1 "C:/DA/ACSTUTestCAA/PROQMFW/ProtectedInterfaces/Action3.h"

#line 786 "C:/DA/ACSTUTestCAA/Aspects/PROQMFramework.m/src/ActionMng.cpp"
class ErrorHandling;
class Profiling;
class IndentedLogging;

#line 6 "C:/DA/ACSTUTestCAA/PROQMFW/ProtectedInterfaces/Action3.h"
class ExportedByPROQMActions Action3
{
#line 794 "C:/DA/ACSTUTestCAA/Aspects/PROQMFramework.m/src/ActionMng.cpp"
  friend class ::ErrorHandling;
  friend class ::Profiling;
  friend class ::IndentedLogging;

#line 7 "C:/DA/ACSTUTestCAA/PROQMFW/ProtectedInterfaces/Action3.h"

  public:
	  
#line 803 "C:/DA/ACSTUTestCAA/Aspects/PROQMFramework.m/src/ActionMng.cpp"


struct TJP__ZN7Action3C1Ev_0 {
  typedef void Result;
  typedef ::Action3 That;
  typedef ::Action3 Target;
  static const int JPID = 169;
  static const AC::JPType JPTYPE = (AC::JPType)16;
  struct Res {
    typedef void Type;
    typedef void ReferredType;
  };
  enum { ARGS = 0 };
  template <int I> struct Arg {
    typedef void Type;
    typedef void ReferredType;
  };

  Target *_target;
  That *_that;

  inline static const char *signature () { return "Action3::Action3()";}
  inline Target *target() {return (Target*)_target;}
  inline That *that() {return (That*)_that;}

};


#line 9 "C:/DA/ACSTUTestCAA/PROQMFW/ProtectedInterfaces/Action3.h"
Action3 ()
#line 834 "C:/DA/ACSTUTestCAA/Aspects/PROQMFramework.m/src/ActionMng.cpp"
{
  TJP__ZN7Action3C1Ev_0 tjp;
  tjp._target =  (TJP__ZN7Action3C1Ev_0::Target*)this;
  tjp._that =  (TJP__ZN7Action3C1Ev_0::That*)this;
  AC::invoke_IndentedLogging_IndentedLogging_a0_before<TJP__ZN7Action3C1Ev_0> (&tjp);
this->__exec_old_C1();
  AC::invoke_IndentedLogging_IndentedLogging_a1_after<TJP__ZN7Action3C1Ev_0> (&tjp);

}
inline void __exec_old_C1()
#line 9 "C:/DA/ACSTUTestCAA/PROQMFW/ProtectedInterfaces/Action3.h"
{	  
#ifdef _WINDOWS_SOURCE
	std::cout<<"_WINDOWS_SOURCE defined"<<std::endl;
#else
	std::cout<<"_WINDOWS_SOURCE not defined"<<std::endl;
#endif
#ifdef __PROQMActions
	std::cout<<"__PROQMActions defined"<<std::endl;
#else
	std::cout<<"__PROQMActions not defined"<<std::endl;
#endif
	std::cout<<"Action3::Action3()"<<std::endl;
	  }
	  
#line 860 "C:/DA/ACSTUTestCAA/Aspects/PROQMFramework.m/src/ActionMng.cpp"


struct TJP__ZN7Action3D1Ev_0 {
  typedef void Result;
  typedef ::Action3 That;
  typedef ::Action3 Target;
  static const int JPID = 169;
  static const AC::JPType JPTYPE = (AC::JPType)32;
  struct Res {
    typedef void Type;
    typedef void ReferredType;
  };
  enum { ARGS = 0 };
  template <int I> struct Arg {
    typedef void Type;
    typedef void ReferredType;
  };

  Target *_target;
  That *_that;

  inline static const char *signature () { return "Action3::~Action3()";}
  inline Target *target() {return (Target*)_target;}
  inline That *that() {return (That*)_that;}

};


#line 22 "C:/DA/ACSTUTestCAA/PROQMFW/ProtectedInterfaces/Action3.h"
virtual ~Action3 ()
#line 891 "C:/DA/ACSTUTestCAA/Aspects/PROQMFramework.m/src/ActionMng.cpp"
{
  TJP__ZN7Action3D1Ev_0 tjp;
  tjp._target =  (TJP__ZN7Action3D1Ev_0::Target*)this;
  tjp._that =  (TJP__ZN7Action3D1Ev_0::That*)this;
  AC::invoke_IndentedLogging_IndentedLogging_a0_before<TJP__ZN7Action3D1Ev_0> (&tjp);
this->__exec_old_D1();
  AC::invoke_IndentedLogging_IndentedLogging_a1_after<TJP__ZN7Action3D1Ev_0> (&tjp);

}
inline void __exec_old_D1()
#line 22 "C:/DA/ACSTUTestCAA/PROQMFW/ProtectedInterfaces/Action3.h"
{
	  	std::cout<<"virtual Action3::~Action3()"<<std::endl;
	}
	
#line 907 "C:/DA/ACSTUTestCAA/Aspects/PROQMFramework.m/src/ActionMng.cpp"


struct TJP__ZN7Action3C1ER7Action3_0 {
  typedef void Result;
  typedef ::Action3 That;
  typedef ::Action3 Target;
  static const int JPID = 169;
  static const AC::JPType JPTYPE = (AC::JPType)16;
  struct Res {
    typedef void Type;
    typedef void ReferredType;
  };
  enum { ARGS = 1 };
  template <int I> struct Arg {
    typedef void Type;
    typedef void ReferredType;
  };
  template <> struct Arg<0> {
    typedef ::Action3 & Type;
    typedef ::Action3 ReferredType;
  };

  Target *_target;
  That *_that;

  inline static const char *signature () { return "Action3::Action3(Action3 &)";}
  inline Target *target() {return (Target*)_target;}
  inline That *that() {return (That*)_that;}

};


#line 25 "C:/DA/ACSTUTestCAA/PROQMFW/ProtectedInterfaces/Action3.h"
Action3(Action3&  arg0)
#line 942 "C:/DA/ACSTUTestCAA/Aspects/PROQMFramework.m/src/ActionMng.cpp"
{
  TJP__ZN7Action3C1ER7Action3_0 tjp;
  tjp._target =  (TJP__ZN7Action3C1ER7Action3_0::Target*)this;
  tjp._that =  (TJP__ZN7Action3C1ER7Action3_0::That*)this;
  AC::invoke_IndentedLogging_IndentedLogging_a0_before<TJP__ZN7Action3C1ER7Action3_0> (&tjp);
this->__exec_old_C1(arg0);
  AC::invoke_IndentedLogging_IndentedLogging_a1_after<TJP__ZN7Action3C1ER7Action3_0> (&tjp);

}
inline void __exec_old_C1(::Action3 & original)
#line 25 "C:/DA/ACSTUTestCAA/PROQMFW/ProtectedInterfaces/Action3.h"
{}
	Action3& operator=(Action3& original){return *this;}

	int execute();
	int checkpoint();
	char* ClassName(){return "Action3";}
private:
	void printface();

};
#endif

#line 1 "C:/DA/ACSTUTestCAA/PROQMFW/PROQMFramework.m/src/ActionMng.cpp"

#line 968 "C:/DA/ACSTUTestCAA/Aspects/PROQMFramework.m/src/ActionMng.cpp"

struct TJP__ZN9ActionMng14executeActionsEv_0_0 {
  typedef int Result;
  typedef ::ActionMng That;
  typedef ::Action1 Target;
  static const int JPID = 109;
  static const AC::JPType JPTYPE = (AC::JPType)4;
  struct Res {
    typedef int Type;
    typedef int ReferredType;
  };
  enum { ARGS = 0 };
  template <int I> struct Arg {
    typedef void Type;
    typedef void ReferredType;
  };

  Result *_result;
  Target *_target;
  That *_that;

  inline static const char *signature () { return "int Action1::execute()";}
  inline Result *result() {return (Result*)_result;}
  inline Target *target() {return (Target*)_target;}
  inline That *that() {return (That*)_that;}

};


struct TJP__ZN9ActionMng14executeActionsEv_0_1 : TJP__ZN9ActionMng14executeActionsEv_0_0 {
  void proceed () {
  AC::invoke_Profiling_Profiling_a0_before<TJP__ZN9ActionMng14executeActionsEv_0_0> (this);
  AC::invoke_IndentedLogging_IndentedLogging_a0_before<TJP__ZN9ActionMng14executeActionsEv_0_0> (this);
  ::new ((AC::ResultBuffer< int  >*)_result) int  (((TJP__ZN9ActionMng14executeActionsEv_0_0::Target*)_target)->execute());
  AC::invoke_IndentedLogging_IndentedLogging_a1_after<TJP__ZN9ActionMng14executeActionsEv_0_0> (this);
  AC::invoke_Profiling_Profiling_a2_after<TJP__ZN9ActionMng14executeActionsEv_0_0> (this);
  }
};


#line 15 "C:/DA/ACSTUTestCAA/PROQMFW/PROQMFramework.m/src/ActionMng.cpp"

#line 1011 "C:/DA/ACSTUTestCAA/Aspects/PROQMFramework.m/src/ActionMng.cpp"

inline int __call__ZN9ActionMng14executeActionsEv_0_1 (::ActionMng *srcthis, ::Action1  *dstthis){
  AC::ResultBuffer< int  > result;
  TJP__ZN9ActionMng14executeActionsEv_0_1 tjp;
  tjp._result = &(TJP__ZN9ActionMng14executeActionsEv_0_1::Result&)result;
  tjp._target =  (TJP__ZN9ActionMng14executeActionsEv_0_1::Target*)dstthis;
  tjp._that =  (TJP__ZN9ActionMng14executeActionsEv_0_1::That*)srcthis;
  AC::invoke_ErrorHandling_ErrorHandling_a0_around<TJP__ZN9ActionMng14executeActionsEv_0_1> (&tjp);
  return (int &)result;
 }

#line 15 "C:/DA/ACSTUTestCAA/PROQMFW/PROQMFramework.m/src/ActionMng.cpp"

#line 1025 "C:/DA/ACSTUTestCAA/Aspects/PROQMFramework.m/src/ActionMng.cpp"

struct TJP__ZN9ActionMng14executeActionsEv_1_0 {
  typedef int Result;
  typedef ::ActionMng That;
  typedef ::Action2 Target;
  static const int JPID = 110;
  static const AC::JPType JPTYPE = (AC::JPType)4;
  struct Res {
    typedef int Type;
    typedef int ReferredType;
  };
  enum { ARGS = 0 };
  template <int I> struct Arg {
    typedef void Type;
    typedef void ReferredType;
  };

  Result *_result;
  Target *_target;
  That *_that;

  inline static const char *signature () { return "int Action2::execute()";}
  inline Result *result() {return (Result*)_result;}
  inline Target *target() {return (Target*)_target;}
  inline That *that() {return (That*)_that;}

};


struct TJP__ZN9ActionMng14executeActionsEv_1_1 : TJP__ZN9ActionMng14executeActionsEv_1_0 {
  void proceed () {
  AC::invoke_Profiling_Profiling_a0_before<TJP__ZN9ActionMng14executeActionsEv_1_0> (this);
  AC::invoke_IndentedLogging_IndentedLogging_a0_before<TJP__ZN9ActionMng14executeActionsEv_1_0> (this);
  ::new ((AC::ResultBuffer< int  >*)_result) int  (((TJP__ZN9ActionMng14executeActionsEv_1_0::Target*)_target)->execute());
  AC::invoke_IndentedLogging_IndentedLogging_a1_after<TJP__ZN9ActionMng14executeActionsEv_1_0> (this);
  AC::invoke_Profiling_Profiling_a2_after<TJP__ZN9ActionMng14executeActionsEv_1_0> (this);
  }
};


#line 15 "C:/DA/ACSTUTestCAA/PROQMFW/PROQMFramework.m/src/ActionMng.cpp"

#line 1068 "C:/DA/ACSTUTestCAA/Aspects/PROQMFramework.m/src/ActionMng.cpp"

inline int __call__ZN9ActionMng14executeActionsEv_1_1 (::ActionMng *srcthis, ::Action2  *dstthis){
  AC::ResultBuffer< int  > result;
  TJP__ZN9ActionMng14executeActionsEv_1_1 tjp;
  tjp._result = &(TJP__ZN9ActionMng14executeActionsEv_1_1::Result&)result;
  tjp._target =  (TJP__ZN9ActionMng14executeActionsEv_1_1::Target*)dstthis;
  tjp._that =  (TJP__ZN9ActionMng14executeActionsEv_1_1::That*)srcthis;
  AC::invoke_ErrorHandling_ErrorHandling_a0_around<TJP__ZN9ActionMng14executeActionsEv_1_1> (&tjp);
  return (int &)result;
 }

#line 15 "C:/DA/ACSTUTestCAA/PROQMFW/PROQMFramework.m/src/ActionMng.cpp"

#line 1082 "C:/DA/ACSTUTestCAA/Aspects/PROQMFramework.m/src/ActionMng.cpp"

struct TJP__ZN9ActionMng14executeActionsEv_2_0 {
  typedef int Result;
  typedef ::ActionMng That;
  typedef ::Action3 Target;
  static const int JPID = 111;
  static const AC::JPType JPTYPE = (AC::JPType)4;
  struct Res {
    typedef int Type;
    typedef int ReferredType;
  };
  enum { ARGS = 0 };
  template <int I> struct Arg {
    typedef void Type;
    typedef void ReferredType;
  };

  Result *_result;
  Target *_target;
  That *_that;

  inline static const char *signature () { return "int Action3::execute()";}
  inline Result *result() {return (Result*)_result;}
  inline Target *target() {return (Target*)_target;}
  inline That *that() {return (That*)_that;}

};


struct TJP__ZN9ActionMng14executeActionsEv_2_1 : TJP__ZN9ActionMng14executeActionsEv_2_0 {
  void proceed () {
  AC::invoke_Profiling_Profiling_a0_before<TJP__ZN9ActionMng14executeActionsEv_2_0> (this);
  AC::invoke_IndentedLogging_IndentedLogging_a0_before<TJP__ZN9ActionMng14executeActionsEv_2_0> (this);
  ::new ((AC::ResultBuffer< int  >*)_result) int  (((TJP__ZN9ActionMng14executeActionsEv_2_0::Target*)_target)->execute());
  AC::invoke_IndentedLogging_IndentedLogging_a1_after<TJP__ZN9ActionMng14executeActionsEv_2_0> (this);
  AC::invoke_Profiling_Profiling_a2_after<TJP__ZN9ActionMng14executeActionsEv_2_0> (this);
  }
};


#line 15 "C:/DA/ACSTUTestCAA/PROQMFW/PROQMFramework.m/src/ActionMng.cpp"

#line 1125 "C:/DA/ACSTUTestCAA/Aspects/PROQMFramework.m/src/ActionMng.cpp"

inline int __call__ZN9ActionMng14executeActionsEv_2_1 (::ActionMng *srcthis, ::Action3  *dstthis){
  AC::ResultBuffer< int  > result;
  TJP__ZN9ActionMng14executeActionsEv_2_1 tjp;
  tjp._result = &(TJP__ZN9ActionMng14executeActionsEv_2_1::Result&)result;
  tjp._target =  (TJP__ZN9ActionMng14executeActionsEv_2_1::Target*)dstthis;
  tjp._that =  (TJP__ZN9ActionMng14executeActionsEv_2_1::That*)srcthis;
  AC::invoke_ErrorHandling_ErrorHandling_a0_around<TJP__ZN9ActionMng14executeActionsEv_2_1> (&tjp);
  return (int &)result;
 }

#line 15 "C:/DA/ACSTUTestCAA/PROQMFW/PROQMFramework.m/src/ActionMng.cpp"
ActionMng::executeActions()
{
	int hr =-1;
	Action1 action_1;
	hr = __call__ZN9ActionMng14executeActionsEv_0_1 ((::ActionMng*)this,&(action_1));
	Action2 action_2;
	hr = __call__ZN9ActionMng14executeActionsEv_1_1 ((::ActionMng*)this,&(action_2));
	Action3 action_3;
	hr = __call__ZN9ActionMng14executeActionsEv_2_1 ((::ActionMng*)this,&(action_3));
	return hr;
}

#line 1150 "C:/DA/ACSTUTestCAA/Aspects/PROQMFramework.m/src/ActionMng.cpp"

#ifdef __ac_FIRST_FILE_C__DA_ACSTUTestCAA_PROQMFW_PROQMFramework_m_src_ActionMng_cpp__
/*** begin of aspect includes ***/
#if !defined(__ac_have_C__DA_ACSTUTestCAA_Aspects_ErrorHandling_ah__) && defined(__ac_need_C__DA_ACSTUTestCAA_Aspects_ErrorHandling_ah__)
#define __ac_have_C__DA_ACSTUTestCAA_Aspects_ErrorHandling_ah__

#line 1 "C:/DA/ACSTUTestCAA/Aspects/ErrorHandling.ah"

#line 1159 "C:/DA/ACSTUTestCAA/Aspects/PROQMFramework.m/src/ActionMng.cpp"

#ifndef __ac_fwd_IndentedLogging__
#define __ac_fwd_IndentedLogging__
class IndentedLogging;
namespace AC {
  template <class JoinPoint>
  inline void invoke_IndentedLogging_IndentedLogging_a0_before (JoinPoint *tjp);
  template <class JoinPoint>
  inline void invoke_IndentedLogging_IndentedLogging_a1_after (JoinPoint *tjp);
}
#endif

#ifndef __ac_need_C__DA_ACSTUTestCAA_Aspects_IndentedLogging_ah__
#define __ac_need_C__DA_ACSTUTestCAA_Aspects_IndentedLogging_ah__
#endif

#line 1 "C:/DA/ACSTUTestCAA/Aspects/ErrorHandling.ah"
#ifndef ErrorHandling_ah
#define ErrorHandling_ah


#line 1 "C:/DA/ACSTUTestCAA/Aspects/ErrorHandling.ah"

#line 1183 "C:/DA/ACSTUTestCAA/Aspects/PROQMFramework.m/src/ActionMng.cpp"
class Profiling;
class IndentedLogging;

#line 6 "C:/DA/ACSTUTestCAA/Aspects/ErrorHandling.ah"
class ErrorHandling
{
#line 1190 "C:/DA/ACSTUTestCAA/Aspects/PROQMFramework.m/src/ActionMng.cpp"

public:
  static ErrorHandling *aspectof () {
    static ErrorHandling __instance;
    return &__instance;
  }
  static ErrorHandling *aspectOf () {
    return aspectof ();
  }
private:

#line 7 "C:/DA/ACSTUTestCAA/Aspects/ErrorHandling.ah"

#line 1204 "C:/DA/ACSTUTestCAA/Aspects/PROQMFramework.m/src/ActionMng.cpp"
  friend class ::Profiling;
  friend class ::IndentedLogging;

#line 7 "C:/DA/ACSTUTestCAA/Aspects/ErrorHandling.ah"

    
#line 8 "C:/DA/ACSTUTestCAA/Aspects/ErrorHandling.ah"

    //pointcut loggedOperations() = call("% PROA%::QueryInterface(...)");// && cflow(execution("void PROA%::%(...)"));

    
#line 3 "C:/DA/ACSTUTestCAA/Aspects/ErrorHandling.ah"

public: template<class JoinPoint> void __a0_around 
#line 11 "C:/DA/ACSTUTestCAA/Aspects/ErrorHandling.ah"

#line 11 "C:/DA/ACSTUTestCAA/Aspects/ErrorHandling.ah"
(JoinPoint *tjp)
#line 11 "C:/DA/ACSTUTestCAA/Aspects/ErrorHandling.ah"

    {
#line 1226 "C:/DA/ACSTUTestCAA/Aspects/PROQMFramework.m/src/ActionMng.cpp"

  typedef typename JoinPoint::That __JP_That;
  typedef typename JoinPoint::Target __JP_Target;
  typedef typename JoinPoint::Result __JP_Result;

#line 12 "C:/DA/ACSTUTestCAA/Aspects/ErrorHandling.ah"

        std::cout<<"++++"<<tjp->signature()<<std::endl;
		//printf("that  : %p\n" , tjp->that());
		//printf("target: %p\n" ,tjp->target());
        try
        {
             tjp->proceed();
        } 
        catch(...)
        {
            std::cout << "ERROR!!!" << std::endl;
            return;
        }
    }
#line 1247 "C:/DA/ACSTUTestCAA/Aspects/PROQMFramework.m/src/ActionMng.cpp"

private:

#line 25 "C:/DA/ACSTUTestCAA/Aspects/ErrorHandling.ah"

	char* ClassName(){return "ErrorHandling";}


#line 1256 "C:/DA/ACSTUTestCAA/Aspects/PROQMFramework.m/src/ActionMng.cpp"

struct TJP__ZN13ErrorHandlingC1Ev_0 {
  typedef void Result;
  typedef ::ErrorHandling That;
  typedef ::ErrorHandling Target;
  static const int JPID = 193;
  static const AC::JPType JPTYPE = (AC::JPType)16;
  struct Res {
    typedef void Type;
    typedef void ReferredType;
  };
  enum { ARGS = 0 };
  template <int I> struct Arg {
    typedef void Type;
    typedef void ReferredType;
  };

  Target *_target;
  That *_that;

  inline static const char *signature () { return "ErrorHandling::ErrorHandling()";}
  inline Target *target() {return (Target*)_target;}
  inline That *that() {return (That*)_that;}

};


#line 28 "C:/DA/ACSTUTestCAA/Aspects/ErrorHandling.ah"

#line 1286 "C:/DA/ACSTUTestCAA/Aspects/PROQMFramework.m/src/ActionMng.cpp"

public:
inline ErrorHandling () {
  TJP__ZN13ErrorHandlingC1Ev_0 tjp;
  tjp._target =  (TJP__ZN13ErrorHandlingC1Ev_0::Target*)this;
  tjp._that =  (TJP__ZN13ErrorHandlingC1Ev_0::That*)this;
  AC::invoke_IndentedLogging_IndentedLogging_a0_before<TJP__ZN13ErrorHandlingC1Ev_0> (&tjp);
  AC::invoke_IndentedLogging_IndentedLogging_a1_after<TJP__ZN13ErrorHandlingC1Ev_0> (&tjp);

}

#line 28 "C:/DA/ACSTUTestCAA/Aspects/ErrorHandling.ah"

#line 1300 "C:/DA/ACSTUTestCAA/Aspects/PROQMFramework.m/src/ActionMng.cpp"

struct TJP__ZN13ErrorHandlingC1ERK13ErrorHandling_0 {
  typedef void Result;
  typedef ::ErrorHandling That;
  typedef ::ErrorHandling Target;
  static const int JPID = 193;
  static const AC::JPType JPTYPE = (AC::JPType)16;
  struct Res {
    typedef void Type;
    typedef void ReferredType;
  };
  enum { ARGS = 1 };
  template <int I> struct Arg {
    typedef void Type;
    typedef void ReferredType;
  };
  template <> struct Arg<0> {
    typedef const ::ErrorHandling & Type;
    typedef const ::ErrorHandling ReferredType;
  };

  Target *_target;
  That *_that;

  inline static const char *signature () { return "ErrorHandling::ErrorHandling(const ErrorHandling &)";}
  inline Target *target() {return (Target*)_target;}
  inline That *that() {return (That*)_that;}

};


#line 28 "C:/DA/ACSTUTestCAA/Aspects/ErrorHandling.ah"

#line 1334 "C:/DA/ACSTUTestCAA/Aspects/PROQMFramework.m/src/ActionMng.cpp"

public:
inline ErrorHandling (const ErrorHandling & arg0)  {
  TJP__ZN13ErrorHandlingC1ERK13ErrorHandling_0 tjp;
  tjp._target =  (TJP__ZN13ErrorHandlingC1ERK13ErrorHandling_0::Target*)this;
  tjp._that =  (TJP__ZN13ErrorHandlingC1ERK13ErrorHandling_0::That*)this;
  AC::invoke_IndentedLogging_IndentedLogging_a0_before<TJP__ZN13ErrorHandlingC1ERK13ErrorHandling_0> (&tjp);
  AC::invoke_IndentedLogging_IndentedLogging_a1_after<TJP__ZN13ErrorHandlingC1ERK13ErrorHandling_0> (&tjp);

}

#line 28 "C:/DA/ACSTUTestCAA/Aspects/ErrorHandling.ah"

#line 1348 "C:/DA/ACSTUTestCAA/Aspects/PROQMFramework.m/src/ActionMng.cpp"

struct TJP__ZN13ErrorHandlingD1Ev_0 {
  typedef void Result;
  typedef ::ErrorHandling That;
  typedef ::ErrorHandling Target;
  static const int JPID = 193;
  static const AC::JPType JPTYPE = (AC::JPType)32;
  struct Res {
    typedef void Type;
    typedef void ReferredType;
  };
  enum { ARGS = 0 };
  template <int I> struct Arg {
    typedef void Type;
    typedef void ReferredType;
  };

  Target *_target;
  That *_that;

  inline static const char *signature () { return "ErrorHandling::~ErrorHandling()";}
  inline Target *target() {return (Target*)_target;}
  inline That *that() {return (That*)_that;}

};


#line 28 "C:/DA/ACSTUTestCAA/Aspects/ErrorHandling.ah"

#line 1378 "C:/DA/ACSTUTestCAA/Aspects/PROQMFramework.m/src/ActionMng.cpp"

public:
inline ~ErrorHandling () {
  TJP__ZN13ErrorHandlingD1Ev_0 tjp;
  tjp._target =  (TJP__ZN13ErrorHandlingD1Ev_0::Target*)this;
  tjp._that =  (TJP__ZN13ErrorHandlingD1Ev_0::That*)this;
  AC::invoke_IndentedLogging_IndentedLogging_a0_before<TJP__ZN13ErrorHandlingD1Ev_0> (&tjp);
  AC::invoke_IndentedLogging_IndentedLogging_a1_after<TJP__ZN13ErrorHandlingD1Ev_0> (&tjp);

}

#line 28 "C:/DA/ACSTUTestCAA/Aspects/ErrorHandling.ah"
};
#line 1392 "C:/DA/ACSTUTestCAA/Aspects/PROQMFramework.m/src/ActionMng.cpp"

namespace AC {
  template <class JoinPoint>
  inline void invoke_ErrorHandling_ErrorHandling_a0_around (JoinPoint *tjp) {
    ::ErrorHandling::aspectof()->__a0_around (tjp);
  }
} 

#line 28 "C:/DA/ACSTUTestCAA/Aspects/ErrorHandling.ah"

#endif
#line 7 "C:/DA/ACSTUTestCAA/PROQMFW/PROQMFramework.m/src/ActionMng.cpp"
#endif
#if !defined(__ac_have_C__DA_ACSTUTestCAA_Aspects_Profiling_ah__) && defined(__ac_need_C__DA_ACSTUTestCAA_Aspects_Profiling_ah__)
#define __ac_have_C__DA_ACSTUTestCAA_Aspects_Profiling_ah__

#line 1 "C:/DA/ACSTUTestCAA/Aspects/Profiling.ah"

#line 1411 "C:/DA/ACSTUTestCAA/Aspects/PROQMFramework.m/src/ActionMng.cpp"

#ifndef __ac_fwd_IndentedLogging__
#define __ac_fwd_IndentedLogging__
class IndentedLogging;
namespace AC {
  template <class JoinPoint>
  inline void invoke_IndentedLogging_IndentedLogging_a0_before (JoinPoint *tjp);
  template <class JoinPoint>
  inline void invoke_IndentedLogging_IndentedLogging_a1_after (JoinPoint *tjp);
}
#endif

#ifndef __ac_need_C__DA_ACSTUTestCAA_Aspects_IndentedLogging_ah__
#define __ac_need_C__DA_ACSTUTestCAA_Aspects_IndentedLogging_ah__
#endif

#line 1 "C:/DA/ACSTUTestCAA/Aspects/Profiling.ah"
#ifndef Profiling_ah
#define Profiling_ah


#line 5 "C:/DA/ACSTUTestCAA/Aspects/Profiling.ah"
#include <windows.h>

#line 1436 "C:/DA/ACSTUTestCAA/Aspects/PROQMFramework.m/src/ActionMng.cpp"
class ErrorHandling;
class IndentedLogging;

#line 6 "C:/DA/ACSTUTestCAA/Aspects/Profiling.ah"
class Profiling {
#line 1442 "C:/DA/ACSTUTestCAA/Aspects/PROQMFramework.m/src/ActionMng.cpp"

public:
  static Profiling *aspectof () {
    static Profiling __instance;
    return &__instance;
  }
  static Profiling *aspectOf () {
    return aspectof ();
  }
private:

#line 6 "C:/DA/ACSTUTestCAA/Aspects/Profiling.ah"

#line 1456 "C:/DA/ACSTUTestCAA/Aspects/PROQMFramework.m/src/ActionMng.cpp"
  friend class ::ErrorHandling;
  friend class ::IndentedLogging;

#line 6 "C:/DA/ACSTUTestCAA/Aspects/Profiling.ah"

	//do intiation of some data members
	
#line 1464 "C:/DA/ACSTUTestCAA/Aspects/PROQMFramework.m/src/ActionMng.cpp"


struct TJP__ZN9ProfilingC1Ev_0 {
  typedef void Result;
  typedef ::Profiling That;
  typedef ::Profiling Target;
  static const int JPID = 170;
  static const AC::JPType JPTYPE = (AC::JPType)16;
  struct Res {
    typedef void Type;
    typedef void ReferredType;
  };
  enum { ARGS = 0 };
  template <int I> struct Arg {
    typedef void Type;
    typedef void ReferredType;
  };

  Target *_target;
  That *_that;

  inline static const char *signature () { return "Profiling::Profiling()";}
  inline Target *target() {return (Target*)_target;}
  inline That *that() {return (That*)_that;}

};


#line 8 "C:/DA/ACSTUTestCAA/Aspects/Profiling.ah"
Profiling () 
#line 1495 "C:/DA/ACSTUTestCAA/Aspects/PROQMFramework.m/src/ActionMng.cpp"
{
  TJP__ZN9ProfilingC1Ev_0 tjp;
  tjp._target =  (TJP__ZN9ProfilingC1Ev_0::Target*)this;
  tjp._that =  (TJP__ZN9ProfilingC1Ev_0::That*)this;
  AC::invoke_IndentedLogging_IndentedLogging_a0_before<TJP__ZN9ProfilingC1Ev_0> (&tjp);
this->__exec_old_C1();
  AC::invoke_IndentedLogging_IndentedLogging_a1_after<TJP__ZN9ProfilingC1Ev_0> (&tjp);

}
inline void __exec_old_C1()
#line 8 "C:/DA/ACSTUTestCAA/Aspects/Profiling.ah"
{
		std::cout<<"this Profiling Profiling()"<<std::endl;

	  timeAmount=0;
	  MaximaTime=80;
  }

  public:
	
#line 16 "C:/DA/ACSTUTestCAA/Aspects/Profiling.ah"

	
#line 17 "C:/DA/ACSTUTestCAA/Aspects/Profiling.ah"


 private:
    DWORD timeAmount;
    DWORD MaximaTime;
	DWORD _dwStart;			//start time
	DWORD _dwEnd;				//end time
   	DWORD _checkpoint;		//check point time
public:
	//dont know, if it has some effect
	static Profiling *instance() {
		std::cout<<"this Profiling instance()"<<std::endl;

		static Profiling profile;
		return &profile;
	} 

	
#line 3 "C:/DA/ACSTUTestCAA/Aspects/Profiling.ah"

public: template<class JoinPoint> void __a0_before 
#line 34 "C:/DA/ACSTUTestCAA/Aspects/Profiling.ah"

#line 34 "C:/DA/ACSTUTestCAA/Aspects/Profiling.ah"
(JoinPoint *tjp)
#line 34 "C:/DA/ACSTUTestCAA/Aspects/Profiling.ah"

	{
#line 1548 "C:/DA/ACSTUTestCAA/Aspects/PROQMFramework.m/src/ActionMng.cpp"

  typedef typename JoinPoint::That __JP_That;
  typedef typename JoinPoint::Target __JP_Target;
  typedef typename JoinPoint::Result __JP_Result;

#line 35 "C:/DA/ACSTUTestCAA/Aspects/Profiling.ah"

		//Set the start time, which should be retrieved by anthoer advice
		_dwStart = getTime();
        std::cout << "This "<<this<<std::endl;
        std::cout << "**loggedOperations _dwStart is " <<_dwStart << std::endl; 
		_dwEnd = 0;
        _checkpoint = 0;
        std::cout << "that name is " <<tjp->that()->ClassName() << std::endl;
        std::cout << "target name is " <<tjp->target()->ClassName() << std::endl;
	}
    
#line 3 "C:/DA/ACSTUTestCAA/Aspects/Profiling.ah"

public: template<class JoinPoint> void __a1_after 
#line 45 "C:/DA/ACSTUTestCAA/Aspects/Profiling.ah"

#line 45 "C:/DA/ACSTUTestCAA/Aspects/Profiling.ah"
(JoinPoint *tjp)
#line 45 "C:/DA/ACSTUTestCAA/Aspects/Profiling.ah"

    {
#line 1576 "C:/DA/ACSTUTestCAA/Aspects/PROQMFramework.m/src/ActionMng.cpp"

  typedef typename JoinPoint::That __JP_That;
  typedef typename JoinPoint::Target __JP_Target;
  typedef typename JoinPoint::Result __JP_Result;

#line 46 "C:/DA/ACSTUTestCAA/Aspects/Profiling.ah"

        _checkpoint = getTime();
        std::cout << "This "<<this<<std::endl;
        std::cout << "**checkedOperations _dwStart is " <<_dwStart << std::endl; 
        std::cout << "target name is " <<tjp->target()->ClassName() << std::endl;
        DWORD tempvalue = _checkpoint - _dwStart;
        std::cout <<"Check point time is " << _checkpoint <<", duration " << tempvalue<< std::endl;
        if(tempvalue>MaximaTime) 
        {
			std::cout << "action exceed the maximal run time, action must be abort!!!"<<std::endl;
            throw ("Expnd Time");		
        }
    }

	
#line 3 "C:/DA/ACSTUTestCAA/Aspects/Profiling.ah"

public: template<class JoinPoint> void __a2_after 
#line 60 "C:/DA/ACSTUTestCAA/Aspects/Profiling.ah"

#line 60 "C:/DA/ACSTUTestCAA/Aspects/Profiling.ah"
(JoinPoint *tjp)
#line 60 "C:/DA/ACSTUTestCAA/Aspects/Profiling.ah"

	{
#line 1608 "C:/DA/ACSTUTestCAA/Aspects/PROQMFramework.m/src/ActionMng.cpp"

  typedef typename JoinPoint::That __JP_That;
  typedef typename JoinPoint::Target __JP_Target;
  typedef typename JoinPoint::Result __JP_Result;

#line 61 "C:/DA/ACSTUTestCAA/Aspects/Profiling.ah"

		_dwEnd =getTime();		
		timeAmount += _dwEnd - _dwStart ;
		std::cout << "*************time span is " <<_dwEnd - _dwStart << std::endl; 
		std::cout << "*************time amount  is " <<timeAmount << std::endl; 
        std::cout << "target name is " <<tjp->target()->ClassName() << std::endl;
	}

	DWORD getTime()
	{
		DWORD tickCount = GetTickCount();
		return tickCount;
	}
	char* ClassName(){return "Profiling";}


#line 1631 "C:/DA/ACSTUTestCAA/Aspects/PROQMFramework.m/src/ActionMng.cpp"

struct TJP__ZN9ProfilingC1ERK9Profiling_0 {
  typedef void Result;
  typedef ::Profiling That;
  typedef ::Profiling Target;
  static const int JPID = 170;
  static const AC::JPType JPTYPE = (AC::JPType)16;
  struct Res {
    typedef void Type;
    typedef void ReferredType;
  };
  enum { ARGS = 1 };
  template <int I> struct Arg {
    typedef void Type;
    typedef void ReferredType;
  };
  template <> struct Arg<0> {
    typedef const ::Profiling & Type;
    typedef const ::Profiling ReferredType;
  };

  Target *_target;
  That *_that;

  inline static const char *signature () { return "Profiling::Profiling(const Profiling &)";}
  inline Target *target() {return (Target*)_target;}
  inline That *that() {return (That*)_that;}

};


#line 76 "C:/DA/ACSTUTestCAA/Aspects/Profiling.ah"

#line 1665 "C:/DA/ACSTUTestCAA/Aspects/PROQMFramework.m/src/ActionMng.cpp"

public:
inline Profiling (const Profiling & arg0) : timeAmount (arg0.timeAmount), MaximaTime (arg0.MaximaTime), _dwStart (arg0._dwStart), _dwEnd (arg0._dwEnd), _checkpoint (arg0._checkpoint) {
  TJP__ZN9ProfilingC1ERK9Profiling_0 tjp;
  tjp._target =  (TJP__ZN9ProfilingC1ERK9Profiling_0::Target*)this;
  tjp._that =  (TJP__ZN9ProfilingC1ERK9Profiling_0::That*)this;
  AC::invoke_IndentedLogging_IndentedLogging_a0_before<TJP__ZN9ProfilingC1ERK9Profiling_0> (&tjp);
  AC::invoke_IndentedLogging_IndentedLogging_a1_after<TJP__ZN9ProfilingC1ERK9Profiling_0> (&tjp);

}

#line 76 "C:/DA/ACSTUTestCAA/Aspects/Profiling.ah"

#line 1679 "C:/DA/ACSTUTestCAA/Aspects/PROQMFramework.m/src/ActionMng.cpp"

struct TJP__ZN9ProfilingD1Ev_0 {
  typedef void Result;
  typedef ::Profiling That;
  typedef ::Profiling Target;
  static const int JPID = 170;
  static const AC::JPType JPTYPE = (AC::JPType)32;
  struct Res {
    typedef void Type;
    typedef void ReferredType;
  };
  enum { ARGS = 0 };
  template <int I> struct Arg {
    typedef void Type;
    typedef void ReferredType;
  };

  Target *_target;
  That *_that;

  inline static const char *signature () { return "Profiling::~Profiling()";}
  inline Target *target() {return (Target*)_target;}
  inline That *that() {return (That*)_that;}

};


#line 76 "C:/DA/ACSTUTestCAA/Aspects/Profiling.ah"

#line 1709 "C:/DA/ACSTUTestCAA/Aspects/PROQMFramework.m/src/ActionMng.cpp"

public:
inline ~Profiling () {
  TJP__ZN9ProfilingD1Ev_0 tjp;
  tjp._target =  (TJP__ZN9ProfilingD1Ev_0::Target*)this;
  tjp._that =  (TJP__ZN9ProfilingD1Ev_0::That*)this;
  AC::invoke_IndentedLogging_IndentedLogging_a0_before<TJP__ZN9ProfilingD1Ev_0> (&tjp);
  AC::invoke_IndentedLogging_IndentedLogging_a1_after<TJP__ZN9ProfilingD1Ev_0> (&tjp);

}

#line 76 "C:/DA/ACSTUTestCAA/Aspects/Profiling.ah"
};
#line 1723 "C:/DA/ACSTUTestCAA/Aspects/PROQMFramework.m/src/ActionMng.cpp"

namespace AC {
  template <class JoinPoint>
  inline void invoke_Profiling_Profiling_a0_before (JoinPoint *tjp) {
    ::Profiling::aspectof()->__a0_before (tjp);
  }
  template <class JoinPoint>
  inline void invoke_Profiling_Profiling_a1_after (JoinPoint *tjp) {
    ::Profiling::aspectof()->__a1_after (tjp);
  }
  template <class JoinPoint>
  inline void invoke_Profiling_Profiling_a2_after (JoinPoint *tjp) {
    ::Profiling::aspectof()->__a2_after (tjp);
  }
} 

#line 76 "C:/DA/ACSTUTestCAA/Aspects/Profiling.ah"

#endif
#line 11 "C:/DA/ACSTUTestCAA/PROQMFW/PROQMFramework.m/src/ActionMng.cpp"
#endif
#if !defined(__ac_have_C__DA_ACSTUTestCAA_Aspects_IndentedLogging_ah__) && defined(__ac_need_C__DA_ACSTUTestCAA_Aspects_IndentedLogging_ah__)
#define __ac_have_C__DA_ACSTUTestCAA_Aspects_IndentedLogging_ah__

#line 1 "C:/DA/ACSTUTestCAA/Aspects/IndentedLogging.ah"

#line 1750 "C:/DA/ACSTUTestCAA/Aspects/PROQMFramework.m/src/ActionMng.cpp"

#ifndef __ac_fwd_IndentedLogging__
#define __ac_fwd_IndentedLogging__
class IndentedLogging;
namespace AC {
  template <class JoinPoint>
  inline void invoke_IndentedLogging_IndentedLogging_a0_before (JoinPoint *tjp);
  template <class JoinPoint>
  inline void invoke_IndentedLogging_IndentedLogging_a1_after (JoinPoint *tjp);
}
#endif

#ifndef __ac_need_C__DA_ACSTUTestCAA_Aspects_IndentedLogging_ah__
#define __ac_need_C__DA_ACSTUTestCAA_Aspects_IndentedLogging_ah__
#endif

#line 1 "C:/DA/ACSTUTestCAA/Aspects/IndentedLogging.ah"
#ifndef IndentedLogging_ah
#define IndentedLogging_ah

#line 1 "C:/DA/ACSTUTestCAA/Aspects/IndentedLogging.ah"

#line 1773 "C:/DA/ACSTUTestCAA/Aspects/PROQMFramework.m/src/ActionMng.cpp"
class ErrorHandling;
class Profiling;

#line 4 "C:/DA/ACSTUTestCAA/Aspects/IndentedLogging.ah"
class IndentedLogging
{
#line 1780 "C:/DA/ACSTUTestCAA/Aspects/PROQMFramework.m/src/ActionMng.cpp"

public:
  static IndentedLogging *aspectof () {
    static IndentedLogging __instance;
    return &__instance;
  }
  static IndentedLogging *aspectOf () {
    return aspectof ();
  }
private:

#line 5 "C:/DA/ACSTUTestCAA/Aspects/IndentedLogging.ah"

#line 1794 "C:/DA/ACSTUTestCAA/Aspects/PROQMFramework.m/src/ActionMng.cpp"
  friend class ::ErrorHandling;
  friend class ::Profiling;

#line 5 "C:/DA/ACSTUTestCAA/Aspects/IndentedLogging.ah"

private:
    void  Indentedprint(const char* sig)
    {
        for(int i = 0; i < _indentationLevel; i++)
        {
            std::cout<<"##";
        }
        std::cout<< sig<<std::endl;
    }

public:
	int _indentationLevel;
	
#line 18 "C:/DA/ACSTUTestCAA/Aspects/IndentedLogging.ah"
// && !within("IndentedLogging");// && !within("Profiling") && !within("ErrorHandling");
	//pointcut  loggedOperations()=call("% ...::%(...)") ||  construction("%") || destruction("%") && !within("IndentedLogging");// && !within("Profiling") && !within("ErrorHandling");
	
#line 1817 "C:/DA/ACSTUTestCAA/Aspects/PROQMFramework.m/src/ActionMng.cpp"


struct TJP__ZN15IndentedLoggingC1Ev_0 {
  typedef void Result;
  typedef ::IndentedLogging That;
  typedef ::IndentedLogging Target;
  static const int JPID = 171;
  static const AC::JPType JPTYPE = (AC::JPType)16;
  struct Res {
    typedef void Type;
    typedef void ReferredType;
  };
  enum { ARGS = 0 };
  template <int I> struct Arg {
    typedef void Type;
    typedef void ReferredType;
  };

  Target *_target;
  That *_that;

  inline static const char *signature () { return "IndentedLogging::IndentedLogging()";}
  inline Target *target() {return (Target*)_target;}
  inline That *that() {return (That*)_that;}

};


#line 20 "C:/DA/ACSTUTestCAA/Aspects/IndentedLogging.ah"
IndentedLogging():_indentationLevel(0)
#line 1848 "C:/DA/ACSTUTestCAA/Aspects/PROQMFramework.m/src/ActionMng.cpp"
{
  TJP__ZN15IndentedLoggingC1Ev_0 tjp;
  tjp._target =  (TJP__ZN15IndentedLoggingC1Ev_0::Target*)this;
  tjp._that =  (TJP__ZN15IndentedLoggingC1Ev_0::That*)this;
  AC::invoke_IndentedLogging_IndentedLogging_a0_before<TJP__ZN15IndentedLoggingC1Ev_0> (&tjp);
this->__exec_old_C1();
  AC::invoke_IndentedLogging_IndentedLogging_a1_after<TJP__ZN15IndentedLoggingC1Ev_0> (&tjp);

}
inline void __exec_old_C1()
#line 20 "C:/DA/ACSTUTestCAA/Aspects/IndentedLogging.ah"
{}
	
#line 3 "C:/DA/ACSTUTestCAA/Aspects/IndentedLogging.ah"

public: template<class JoinPoint> void __a0_before 
#line 21 "C:/DA/ACSTUTestCAA/Aspects/IndentedLogging.ah"

#line 21 "C:/DA/ACSTUTestCAA/Aspects/IndentedLogging.ah"
(JoinPoint *tjp)
#line 21 "C:/DA/ACSTUTestCAA/Aspects/IndentedLogging.ah"

	{
#line 1872 "C:/DA/ACSTUTestCAA/Aspects/PROQMFramework.m/src/ActionMng.cpp"

  typedef typename JoinPoint::That __JP_That;
  typedef typename JoinPoint::Target __JP_Target;
  typedef typename JoinPoint::Result __JP_Result;

#line 22 "C:/DA/ACSTUTestCAA/Aspects/IndentedLogging.ah"

		_indentationLevel++;
		std::cout<<"Enter:"<<tjp->that()->ClassName()<<":"<<tjp->target()->ClassName();
		Indentedprint(tjp->signature());
	}
	
#line 3 "C:/DA/ACSTUTestCAA/Aspects/IndentedLogging.ah"

public: template<class JoinPoint> void __a1_after 
#line 27 "C:/DA/ACSTUTestCAA/Aspects/IndentedLogging.ah"

#line 27 "C:/DA/ACSTUTestCAA/Aspects/IndentedLogging.ah"
(JoinPoint *tjp)
#line 27 "C:/DA/ACSTUTestCAA/Aspects/IndentedLogging.ah"

	{
#line 1895 "C:/DA/ACSTUTestCAA/Aspects/PROQMFramework.m/src/ActionMng.cpp"

  typedef typename JoinPoint::That __JP_That;
  typedef typename JoinPoint::Target __JP_Target;
  typedef typename JoinPoint::Result __JP_Result;

#line 28 "C:/DA/ACSTUTestCAA/Aspects/IndentedLogging.ah"

		std::cout<<"Leave:"<<tjp->that()->ClassName()<<":"<<tjp->target()->ClassName();
		Indentedprint(tjp->signature());
		_indentationLevel--;
	}
	char* ClassName(){return "IndentedLogging";}


#line 1910 "C:/DA/ACSTUTestCAA/Aspects/PROQMFramework.m/src/ActionMng.cpp"

struct TJP__ZN15IndentedLoggingC1ERK15IndentedLogging_0 {
  typedef void Result;
  typedef ::IndentedLogging That;
  typedef ::IndentedLogging Target;
  static const int JPID = 171;
  static const AC::JPType JPTYPE = (AC::JPType)16;
  struct Res {
    typedef void Type;
    typedef void ReferredType;
  };
  enum { ARGS = 1 };
  template <int I> struct Arg {
    typedef void Type;
    typedef void ReferredType;
  };
  template <> struct Arg<0> {
    typedef const ::IndentedLogging & Type;
    typedef const ::IndentedLogging ReferredType;
  };

  Target *_target;
  That *_that;

  inline static const char *signature () { return "IndentedLogging::IndentedLogging(const IndentedLogging &)";}
  inline Target *target() {return (Target*)_target;}
  inline That *that() {return (That*)_that;}

};


#line 35 "C:/DA/ACSTUTestCAA/Aspects/IndentedLogging.ah"

#line 1944 "C:/DA/ACSTUTestCAA/Aspects/PROQMFramework.m/src/ActionMng.cpp"

public:
inline IndentedLogging (const IndentedLogging & arg0) : _indentationLevel (arg0._indentationLevel) {
  TJP__ZN15IndentedLoggingC1ERK15IndentedLogging_0 tjp;
  tjp._target =  (TJP__ZN15IndentedLoggingC1ERK15IndentedLogging_0::Target*)this;
  tjp._that =  (TJP__ZN15IndentedLoggingC1ERK15IndentedLogging_0::That*)this;
  AC::invoke_IndentedLogging_IndentedLogging_a0_before<TJP__ZN15IndentedLoggingC1ERK15IndentedLogging_0> (&tjp);
  AC::invoke_IndentedLogging_IndentedLogging_a1_after<TJP__ZN15IndentedLoggingC1ERK15IndentedLogging_0> (&tjp);

}

#line 35 "C:/DA/ACSTUTestCAA/Aspects/IndentedLogging.ah"

#line 1958 "C:/DA/ACSTUTestCAA/Aspects/PROQMFramework.m/src/ActionMng.cpp"

struct TJP__ZN15IndentedLoggingD1Ev_0 {
  typedef void Result;
  typedef ::IndentedLogging That;
  typedef ::IndentedLogging Target;
  static const int JPID = 171;
  static const AC::JPType JPTYPE = (AC::JPType)32;
  struct Res {
    typedef void Type;
    typedef void ReferredType;
  };
  enum { ARGS = 0 };
  template <int I> struct Arg {
    typedef void Type;
    typedef void ReferredType;
  };

  Target *_target;
  That *_that;

  inline static const char *signature () { return "IndentedLogging::~IndentedLogging()";}
  inline Target *target() {return (Target*)_target;}
  inline That *that() {return (That*)_that;}

};


#line 35 "C:/DA/ACSTUTestCAA/Aspects/IndentedLogging.ah"

#line 1988 "C:/DA/ACSTUTestCAA/Aspects/PROQMFramework.m/src/ActionMng.cpp"

public:
inline ~IndentedLogging () {
  TJP__ZN15IndentedLoggingD1Ev_0 tjp;
  tjp._target =  (TJP__ZN15IndentedLoggingD1Ev_0::Target*)this;
  tjp._that =  (TJP__ZN15IndentedLoggingD1Ev_0::That*)this;
  AC::invoke_IndentedLogging_IndentedLogging_a0_before<TJP__ZN15IndentedLoggingD1Ev_0> (&tjp);
  AC::invoke_IndentedLogging_IndentedLogging_a1_after<TJP__ZN15IndentedLoggingD1Ev_0> (&tjp);

}

#line 35 "C:/DA/ACSTUTestCAA/Aspects/IndentedLogging.ah"
};
#line 2002 "C:/DA/ACSTUTestCAA/Aspects/PROQMFramework.m/src/ActionMng.cpp"

namespace AC {
  template <class JoinPoint>
  inline void invoke_IndentedLogging_IndentedLogging_a0_before (JoinPoint *tjp) {
    ::IndentedLogging::aspectof()->__a0_before (tjp);
  }
  template <class JoinPoint>
  inline void invoke_IndentedLogging_IndentedLogging_a1_after (JoinPoint *tjp) {
    ::IndentedLogging::aspectof()->__a1_after (tjp);
  }
} 

#line 35 "C:/DA/ACSTUTestCAA/Aspects/IndentedLogging.ah"

#endif

#line 15 "C:/DA/ACSTUTestCAA/PROQMFW/PROQMFramework.m/src/ActionMng.cpp"
#endif
/*** end of aspect includes ***/
#undef __ac_FIRST_C__DA_ACSTUTestCAA__
#undef __ac_FIRST_FILE_C__DA_ACSTUTestCAA_PROQMFW_PROQMFramework_m_src_ActionMng_cpp__
#endif // __ac_FIRST_FILE_C__DA_ACSTUTestCAA_PROQMFW_PROQMFramework_m_src_ActionMng_cpp__
